/* ListView.c generated by valac 0.56.17, the Vala compiler
 * generated from ListView.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgiemenuapplet.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "budgie-appindexer.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#define APPLICATION_LIST_VIEW_HEIGHT 510
#define APPLICATION_LIST_VIEW_WIDTH 300
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APPLICATION_LIST_VIEW_0_PROPERTY,
	APPLICATION_LIST_VIEW_SETTINGS_PROPERTY,
	APPLICATION_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* application_list_view_properties[APPLICATION_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ApplicationListViewPrivate {
	gint SCALED_HEIGHT;
	gint SCALED_WIDTH;
	GtkBox* categories;
	GtkListBox* applications;
	GtkScrolledWindow* categories_scroll;
	GtkScrolledWindow* content_scroll;
	CategoryButton* all_categories;
	GSettings* _settings;
	BudgieCategory* current_category;
	gboolean compact_mode;
	gboolean headers_visible;
	gboolean show_control_center_panels;
	gboolean rollover_menus;
	gboolean reloading;
	GRecMutex __lock_reloading;
};

struct _Block1Data {
	int _ref_count_;
	ApplicationListView* self;
	BudgieAppIndex* app_tracker;
};

struct _Block2Data {
	int _ref_count_;
	ApplicationListView* self;
	CategoryButton* btn;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	BudgieApplication* app;
};

static gint ApplicationListView_private_offset;
static gpointer application_list_view_parent_class = NULL;
static GType application_list_view_type_id = 0;

static void application_list_view_set_scaled_sizing (ApplicationListView* self);
static void application_list_view_real_refresh (ApplicationView* base,
                                         BudgieAppIndex* app_tracker);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda7_ (ApplicationListView* self,
                 GtkWidget* child);
static void ___lambda7__gfunc (gconstpointer data,
                        gpointer self);
static gboolean __lambda8_ (Block1Data* _data1_);
static void application_list_view_load_menus (ApplicationListView* self,
                                       BudgieAppIndex* app_tracker);
static gboolean ___lambda8__gsource_func (gpointer self);
static gboolean application_list_view_on_mouse_enter (ApplicationListView* self,
                                               GtkWidget* source_widget,
                                               GdkEventCrossing* e);
static gboolean _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                              GdkEventCrossing* event,
                                                                              gpointer self);
static void __lambda9_ (ApplicationListView* self);
static void application_list_view_update_category (ApplicationListView* self,
                                            CategoryButton* btn);
static void ___lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ____lambda10_ (Block2Data* _data2_);
static void _____lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                               gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ______lambda11_ (Block3Data* _data3_);
static void _______lambda11__gtk_button_clicked (GtkButton* _sender,
                                          gpointer self);
static void application_list_view_real_invalidate (ApplicationView* base);
static void application_list_view_real_on_search_entry_activated (ApplicationView* base);
static void application_list_view_on_settings_changed (ApplicationListView* self,
                                                const gchar* key);
static void application_list_view_do_list_header (ApplicationListView* self,
                                           GtkListBoxRow* before,
                                           GtkListBoxRow* after);
static void _application_list_view_do_list_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                            GtkListBoxRow* before,
                                                                            gpointer self);
static void application_list_view_on_row_activate (ApplicationListView* self,
                                            GtkListBoxRow* row);
static gboolean application_list_view_do_filter_list (ApplicationListView* self,
                                               GtkListBoxRow* row);
static gint application_list_view_do_sort_list (ApplicationListView* self,
                                         GtkListBoxRow* row1,
                                         GtkListBoxRow* row2);
static void application_list_view_real_on_show (ApplicationView* base);
static GObject * application_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _application_list_view___lambda12_ (ApplicationListView* self);
static void __application_list_view___lambda12__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _application_list_view___lambda13_ (ApplicationListView* self);
static void __application_list_view___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                    gpointer self);
static void _application_list_view_on_row_activate_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void _application_list_view_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static gboolean _application_list_view_do_filter_list_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                         gpointer self);
static gint _application_list_view_do_sort_list_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self);
static void application_list_view_finalize (GObject * obj);
static void _vala_application_list_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_application_list_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
application_list_view_get_instance_private (ApplicationListView* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationListView_private_offset);
}

ApplicationListView*
application_list_view_construct (GType object_type,
                                 GSettings* settings)
{
	ApplicationListView * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 43 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 44 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) g_object_new (object_type, "settings", settings, "orientation", GTK_ORIENTATION_HORIZONTAL, "spacing", 0, NULL);
#line 50 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 50 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _tmp0_;
#line 50 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_HEIGHT = APPLICATION_LIST_VIEW_HEIGHT / _tmp1_;
#line 51 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 51 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _tmp2_;
#line 51 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_WIDTH = APPLICATION_LIST_VIEW_WIDTH / _tmp3_;
#line 43 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return self;
#line 209 "ListView.c"
}

ApplicationListView*
application_list_view_new (GSettings* settings)
{
#line 43 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return application_list_view_construct (TYPE_APPLICATION_LIST_VIEW, settings);
#line 217 "ListView.c"
}

/**
* Sets various widgets to use sizing based on current scale and our default HEIGHT
*/
static void
application_list_view_set_scaled_sizing (ApplicationListView* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkScrolledWindow* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkListBox* _tmp6_;
#line 135 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _tmp0_;
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_HEIGHT = APPLICATION_LIST_VIEW_HEIGHT / _tmp1_;
#line 137 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 137 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_WIDTH = APPLICATION_LIST_VIEW_WIDTH / _tmp3_;
#line 138 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, self->priv->SCALED_WIDTH, self->priv->SCALED_HEIGHT);
#line 140 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = self->priv->categories_scroll;
#line 140 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp4_, self->priv->SCALED_HEIGHT);
#line 141 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->content_scroll;
#line 141 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp5_, self->priv->SCALED_HEIGHT);
#line 142 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = self->priv->applications;
#line 142 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set ((GtkWidget*) _tmp6_, "height-request", self->priv->SCALED_HEIGHT, NULL);
#line 261 "ListView.c"
}

/**
 * Refreshes the category and application lists.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 272 "ListView.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data1_;
#line 282 "ListView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 292 "ListView.c"
		ApplicationListView* self;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data1_->self;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data1_->app_tracker);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block1Data, _data1_);
#line 302 "ListView.c"
	}
}

static void
__lambda7_ (ApplicationListView* self,
            GtkWidget* child)
{
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (child != NULL);
#line 165 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_destroy (child);
#line 314 "ListView.c"
}

static void
___lambda7__gfunc (gconstpointer data,
                   gpointer self)
{
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	__lambda7_ ((ApplicationListView*) self, (GtkWidget*) data);
#line 323 "ListView.c"
}

static gboolean
__lambda8_ (Block1Data* _data1_)
{
	ApplicationListView* self;
	gboolean result;
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data1_->self;
#line 170 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_load_menus (self, _data1_->app_tracker);
#line 171 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_view_invalidate ((ApplicationView*) self);
#line 172 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = FALSE;
#line 172 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 341 "ListView.c"
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ (self);
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 351 "ListView.c"
}

static void
application_list_view_real_refresh (ApplicationView* base,
                                    BudgieAppIndex* app_tracker)
{
	ApplicationListView * self;
	Block1Data* _data1_;
	BudgieAppIndex* _tmp0_;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GtkBox* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (app_tracker != NULL);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->_ref_count_ = 1;
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->self = g_object_ref (self);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _g_object_ref0 (app_tracker);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (_data1_->app_tracker);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->app_tracker = _tmp0_;
#line 387 "ListView.c"
	{
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_rec_mutex_lock (&self->priv->__lock_reloading);
#line 391 "ListView.c"
		{
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (self->priv->reloading) {
#line 395 "ListView.c"
				{
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 399 "ListView.c"
				}
#line 151 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block1_data_unref (_data1_);
#line 151 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data1_ = NULL;
#line 151 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return;
#line 407 "ListView.c"
			}
#line 153 "../src/panel/applets/budgie-menu/views/ListView.vala"
			self->priv->reloading = TRUE;
#line 411 "ListView.c"
		}
		__finally0:
		{
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 417 "ListView.c"
		}
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block1_data_unref (_data1_);
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data1_ = NULL;
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return;
#line 431 "ListView.c"
		}
	}
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->applications;
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 438 "ListView.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child_collection = _tmp2_;
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 446 "ListView.c"
			GtkWidget* child = NULL;
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
			child = (GtkWidget*) child_it->data;
#line 450 "ListView.c"
			{
				GtkWidget* _tmp3_;
#line 158 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp3_ = child;
#line 158 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_destroy (_tmp3_);
#line 457 "ListView.c"
			}
		}
#line 157 "../src/panel/applets/budgie-menu/views/ListView.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 462 "ListView.c"
	}
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = application_view_get_application_buttons ((ApplicationView*) self);
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = _tmp4_;
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_hash_table_remove_all (_tmp5_);
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = application_view_get_control_center_buttons ((ApplicationView*) self);
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = _tmp6_;
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp7_);
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = self->priv->categories;
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = gtk_container_get_children ((GtkContainer*) _tmp8_);
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp10_ = _tmp9_;
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_list_foreach (_tmp10_, ___lambda7__gfunc, self);
#line 164 "../src/panel/applets/budgie-menu/views/ListView.vala"
	(_tmp10_ == NULL) ? NULL : (_tmp10_ = (g_list_free (_tmp10_), NULL));
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 488 "ListView.c"
	{
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_rec_mutex_lock (&self->priv->__lock_reloading);
#line 492 "ListView.c"
		{
#line 176 "../src/panel/applets/budgie-menu/views/ListView.vala"
			self->priv->reloading = FALSE;
#line 496 "ListView.c"
		}
		__finally1:
		{
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 502 "ListView.c"
		}
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block1_data_unref (_data1_);
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data1_ = NULL;
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_clear_error (&_inner_error0_);
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return;
#line 516 "ListView.c"
		}
	}
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	block1_data_unref (_data1_);
#line 148 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_ = NULL;
#line 523 "ListView.c"
}

/**
 * Build the category and application lists.
 */
static gboolean
_application_list_view_on_mouse_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                     GdkEventCrossing* event,
                                                                     gpointer self)
{
	gboolean result;
	result = application_list_view_on_mouse_enter ((ApplicationListView*) self, _sender, event);
#line 186 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 538 "ListView.c"
}

static void
__lambda9_ (ApplicationListView* self)
{
	CategoryButton* _tmp0_;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 549 "ListView.c"
}

static void
___lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	__lambda9_ ((ApplicationListView*) self);
#line 558 "ListView.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data2_;
#line 568 "ListView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 578 "ListView.c"
		ApplicationListView* self;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data2_->self;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data2_->btn);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block2Data, _data2_);
#line 588 "ListView.c"
	}
}

static void
____lambda10_ (Block2Data* _data2_)
{
	ApplicationListView* self;
	CategoryButton* _tmp0_;
#line 203 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data2_->self;
#line 204 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _data2_->btn;
#line 204 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 603 "ListView.c"
}

static void
_____lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                          gpointer self)
{
#line 203 "../src/panel/applets/budgie-menu/views/ListView.vala"
	____lambda10_ (self);
#line 612 "ListView.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data3_;
#line 622 "ListView.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 632 "ListView.c"
		ApplicationListView* self;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data3_->_data2_->self;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data3_->app);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
		block2_data_unref (_data3_->_data2_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_data3_->_data2_ = NULL;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block3Data, _data3_);
#line 644 "ListView.c"
	}
}

static void
______lambda11_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	ApplicationListView* self;
	BudgieApplication* _tmp0_;
#line 214 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data2_ = _data3_->_data2_;
#line 214 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data2_->self;
#line 215 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _data3_->app;
#line 215 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp0_);
#line 216 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 664 "ListView.c"
}

static void
_______lambda11__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self)
{
#line 214 "../src/panel/applets/budgie-menu/views/ListView.vala"
	______lambda11_ (self);
#line 673 "ListView.c"
}

static void
application_list_view_load_menus (ApplicationListView* self,
                                  BudgieAppIndex* app_tracker)
{
	CategoryButton* _tmp0_;
	CategoryButton* _tmp1_;
	CategoryButton* _tmp2_;
	CategoryButton* _tmp3_;
	GtkBox* _tmp4_;
	CategoryButton* _tmp5_;
#line 183 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (app_tracker != NULL);
#line 185 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = category_button_new (NULL);
#line 185 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp0_);
#line 185 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 185 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->all_categories = _tmp0_;
#line 186 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->all_categories;
#line 186 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->all_categories;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp2_, "toggled", (GCallback) ___lambda9__gtk_toggle_button_toggled, self, 0);
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->all_categories;
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 191 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = self->priv->categories;
#line 191 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->all_categories;
#line 191 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp4_, (GtkWidget*) _tmp5_, FALSE, TRUE, (guint) 0);
#line 716 "ListView.c"
	{
		GeeArrayList* _category_list = NULL;
		GeeArrayList* _tmp6_;
		gint _category_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _category_index = 0;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = budgie_app_index_get_categories (app_tracker);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_list = _tmp6_;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = _category_list;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = _tmp8_;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_size = _tmp9_;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_index = -1;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		while (TRUE) {
#line 741 "ListView.c"
			Block2Data* _data2_;
			gint _tmp10_;
			gint _tmp11_;
			BudgieCategory* category = NULL;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			BudgieCategory* _tmp14_;
			GeeArrayList* _tmp15_;
			GeeArrayList* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
			BudgieCategory* _tmp19_;
			CategoryButton* _tmp20_;
			CategoryButton* _tmp21_;
			CategoryButton* _tmp22_;
			CategoryButton* _tmp23_;
			CategoryButton* _tmp24_;
			CategoryButton* _tmp25_;
			GtkBox* _tmp26_;
			CategoryButton* _tmp27_;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_ = g_slice_new0 (Block2Data);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->_ref_count_ = 1;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->self = g_object_ref (self);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_category_index = _category_index + 1;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp10_ = _category_index;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp11_ = _category_size;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block2_data_unref (_data2_);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data2_ = NULL;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 782 "ListView.c"
			}
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp12_ = _category_list;
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _category_index);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			category = (BudgieCategory*) _tmp13_;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp14_ = category;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp15_ = budgie_category_get_apps (_tmp14_);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp16_ = _tmp15_;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp17_ = gee_collection_get_is_empty ((GeeCollection*) _tmp16_);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp18_ = _tmp17_;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (_tmp18_) {
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (category);
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block2_data_unref (_data2_);
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data2_ = NULL;
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
				continue;
#line 810 "ListView.c"
			}
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp19_ = category;
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp20_ = category_button_new (_tmp19_);
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_object_ref_sink (_tmp20_);
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->btn = _tmp20_;
#line 201 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp21_ = _data2_->btn;
#line 201 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp22_ = self->priv->all_categories;
#line 201 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_radio_button_join_group ((GtkRadioButton*) _tmp21_, (GtkRadioButton*) _tmp22_);
#line 202 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp23_ = _data2_->btn;
#line 202 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_signal_connect_object ((GtkWidget*) _tmp23_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 203 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp24_ = _data2_->btn;
#line 203 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_signal_connect_data ((GtkToggleButton*) _tmp24_, "toggled", (GCallback) _____lambda10__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 207 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp25_ = _data2_->btn;
#line 207 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp25_);
#line 208 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp26_ = self->priv->categories;
#line 208 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp27_ = _data2_->btn;
#line 208 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_box_pack_start (_tmp26_, (GtkWidget*) _tmp27_, FALSE, TRUE, (guint) 0);
#line 844 "ListView.c"
			{
				GeeArrayList* _app_list = NULL;
				BudgieCategory* _tmp28_;
				GeeArrayList* _tmp29_;
				GeeArrayList* _tmp30_;
				gint _app_size = 0;
				GeeArrayList* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _app_index = 0;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp28_ = category;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp29_ = budgie_category_get_apps (_tmp28_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp30_ = _tmp29_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_list = _tmp30_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp31_ = _app_list;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp33_ = _tmp32_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_size = _tmp33_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_index = -1;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
				while (TRUE) {
#line 875 "ListView.c"
					Block3Data* _data3_;
					gint _tmp34_;
					gint _tmp35_;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
					MenuButton* app_btn = NULL;
					BudgieApplication* _tmp38_;
					BudgieCategory* _tmp39_;
					gint _tmp40_;
					gint _tmp41_;
					MenuButton* _tmp42_;
					MenuButton* _tmp43_;
					GHashTable* _tmp44_;
					GHashTable* _tmp45_;
					BudgieApplication* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					gchar* _tmp49_;
					MenuButton* _tmp50_;
					MenuButton* _tmp51_;
					MenuButton* _tmp52_;
					GtkListBox* _tmp53_;
					MenuButton* _tmp54_;
					MenuButton* _tmp55_;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_ = g_slice_new0 (Block3Data);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->_ref_count_ = 1;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->_data2_ = block2_data_ref (_data2_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_app_index = _app_index + 1;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp34_ = _app_index;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp35_ = _app_size;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (!(_tmp34_ < _tmp35_)) {
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
						block3_data_unref (_data3_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_data3_ = NULL;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
						break;
#line 920 "ListView.c"
					}
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp36_ = _app_list;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _app_index);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->app = (BudgieApplication*) _tmp37_;
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp38_ = _data3_->app;
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp39_ = category;
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp40_ = application_view_get_icon_size ((ApplicationView*) self);
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp41_ = _tmp40_;
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp42_ = menu_button_new (_tmp38_, _tmp39_, _tmp41_);
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_object_ref_sink (_tmp42_);
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
					app_btn = _tmp42_;
#line 214 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp43_ = app_btn;
#line 214 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_signal_connect_data ((GtkButton*) _tmp43_, "clicked", (GCallback) _______lambda11__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp44_ = application_view_get_application_buttons ((ApplicationView*) self);
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp45_ = _tmp44_;
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp46_ = _data3_->app;
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp47_ = budgie_application_get_desktop_id (_tmp46_);
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp48_ = _tmp47_;
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp49_ = g_strdup (_tmp48_);
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp50_ = app_btn;
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp51_ = _g_object_ref0 (_tmp50_);
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_hash_table_insert (_tmp45_, _tmp49_, _tmp51_);
#line 220 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp52_ = app_btn;
#line 220 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_widget_show_all ((GtkWidget*) _tmp52_);
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp53_ = self->priv->applications;
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp54_ = app_btn;
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp55_ = app_btn;
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (menu_button_is_control_center_panel (_tmp55_)) {
#line 978 "ListView.c"
						GeeArrayList* _tmp56_;
						GeeArrayList* _tmp57_;
						MenuButton* _tmp58_;
#line 224 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp56_ = application_view_get_control_center_buttons ((ApplicationView*) self);
#line 224 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp57_ = _tmp56_;
#line 224 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp58_ = app_btn;
#line 224 "../src/panel/applets/budgie-menu/views/ListView.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp58_);
#line 990 "ListView.c"
					}
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_g_object_unref0 (app_btn);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					block3_data_unref (_data3_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_ = NULL;
#line 998 "ListView.c"
				}
			}
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (category);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block2_data_unref (_data2_);
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_ = NULL;
#line 1007 "ListView.c"
		}
#line 193 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_category_list);
#line 1011 "ListView.c"
	}
}

/**
 * Invalidate the application headers, filters, and sorting.
 */
static void
application_list_view_real_invalidate (ApplicationView* base)
{
	ApplicationListView * self;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
#line 233 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 234 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->applications;
#line 234 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_headers (_tmp0_);
#line 235 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->applications;
#line 235 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_filter (_tmp1_);
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->applications;
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_sort (_tmp2_);
#line 1039 "ListView.c"
}

/**
 * Launches the application selected by the current search result.
 */
static void
application_list_view_real_on_search_entry_activated (ApplicationView* base)
{
	ApplicationListView * self;
	GtkListBoxRow* selected = NULL;
	GList* rows = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkListBoxRow* _tmp13_;
	MenuButton* btn = NULL;
	GtkListBoxRow* _tmp14_;
	GtkWidget* _tmp15_;
	MenuButton* _tmp16_;
	MenuButton* _tmp17_;
	BudgieApplication* _tmp18_;
	BudgieApplication* _tmp19_;
#line 242 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 243 "../src/panel/applets/budgie-menu/views/ListView.vala"
	selected = NULL;
#line 245 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->applications;
#line 245 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = gtk_list_box_get_selected_rows (_tmp0_);
#line 245 "../src/panel/applets/budgie-menu/views/ListView.vala"
	rows = _tmp1_;
#line 246 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = rows;
#line 246 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp2_ != NULL) {
#line 1076 "ListView.c"
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkListBoxRow* _tmp5_;
#line 247 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = rows;
#line 247 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = _tmp3_->data;
#line 247 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp5_ = _g_object_ref0 ((GtkListBoxRow*) _tmp4_);
#line 247 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (selected);
#line 247 "../src/panel/applets/budgie-menu/views/ListView.vala"
		selected = _tmp5_;
#line 1090 "ListView.c"
	} else {
		GtkListBox* _tmp6_;
		GList* _tmp7_;
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = self->priv->applications;
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
#line 1098 "ListView.c"
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
			child_collection = _tmp7_;
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1106 "ListView.c"
				GtkWidget* child = NULL;
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
				child = (GtkWidget*) child_it->data;
#line 1110 "ListView.c"
				{
					gboolean _tmp8_ = FALSE;
					GtkWidget* _tmp9_;
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp9_ = child;
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (gtk_widget_get_visible (_tmp9_)) {
#line 1118 "ListView.c"
						GtkWidget* _tmp10_;
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp10_ = child;
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp8_ = gtk_widget_get_child_visible (_tmp10_);
#line 1124 "ListView.c"
					} else {
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp8_ = FALSE;
#line 1128 "ListView.c"
					}
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (_tmp8_) {
#line 1132 "ListView.c"
						GtkWidget* _tmp11_;
						GtkListBoxRow* _tmp12_;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp11_ = child;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_list_box_row_get_type ()) ? ((GtkListBoxRow*) _tmp11_) : NULL);
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_g_object_unref0 (selected);
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
						selected = _tmp12_;
#line 252 "../src/panel/applets/budgie-menu/views/ListView.vala"
						break;
#line 1145 "ListView.c"
					}
				}
			}
#line 249 "../src/panel/applets/budgie-menu/views/ListView.vala"
			(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1151 "ListView.c"
		}
	}
#line 256 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp13_ = selected;
#line 256 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp13_ == NULL) {
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
		(rows == NULL) ? NULL : (rows = (g_list_free (rows), NULL));
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (selected);
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1164 "ListView.c"
	}
#line 260 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = selected;
#line 260 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = gtk_bin_get_child ((GtkBin*) _tmp14_);
#line 260 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp16_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp15_) ? ((MenuButton*) _tmp15_) : NULL);
#line 260 "../src/panel/applets/budgie-menu/views/ListView.vala"
	btn = _tmp16_;
#line 261 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp17_ = btn;
#line 261 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = menu_button_get_app (_tmp17_);
#line 261 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = _tmp18_;
#line 261 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp19_);
#line 262 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 242 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (btn);
#line 242 "../src/panel/applets/budgie-menu/views/ListView.vala"
	(rows == NULL) ? NULL : (rows = (g_list_free (rows), NULL));
#line 242 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (selected);
#line 1190 "ListView.c"
}

/**
 * Permits "rolling" over categories.
 */
static gboolean
application_list_view_on_mouse_enter (ApplicationListView* self,
                                      GtkWidget* source_widget,
                                      GdkEventCrossing* e)
{
	GtkToggleButton* b = NULL;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkToggleButton* _tmp2_;
	GtkToggleButton* _tmp4_;
	gboolean result;
#line 268 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (source_widget != NULL, FALSE);
#line 268 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 269 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!self->priv->rollover_menus) {
#line 270 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 270 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1219 "ListView.c"
	}
#line 274 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (source_widget, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) source_widget) : NULL);
#line 274 "../src/panel/applets/budgie-menu/views/ListView.vala"
	b = _tmp0_;
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = b;
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!gtk_widget_get_sensitive ((GtkWidget*) _tmp2_)) {
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = TRUE;
#line 1231 "ListView.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = b;
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = !gtk_widget_get_visible ((GtkWidget*) _tmp3_);
#line 1238 "ListView.c"
	}
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp1_) {
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (b);
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1248 "ListView.c"
	}
#line 280 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = b;
#line 280 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_toggle_button_set_active (_tmp4_, TRUE);
#line 281 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 281 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (b);
#line 281 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 1260 "ListView.c"
}

/**
 * Handles changes to our applet settings.
 */
static void
_application_list_view_do_list_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                       GtkListBoxRow* before,
                                                                       gpointer self)
{
#line 300 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_do_list_header ((ApplicationListView*) self, row, before);
#line 1273 "ListView.c"
}

static void
application_list_view_on_settings_changed (ApplicationListView* self,
                                           const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label0 = 0;
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label1 = 0;
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label2 = 0;
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label3 = 0;
#line 287 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (key != NULL);
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = key;
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("menu-compact")))) {
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1302 "ListView.c"
			default:
			{
				gboolean vis = FALSE;
				GSettings* _tmp3_;
				GtkScrolledWindow* _tmp4_;
				GtkScrolledWindow* _tmp5_;
#line 290 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp3_ = self->priv->_settings;
#line 290 "../src/panel/applets/budgie-menu/views/ListView.vala"
				vis = g_settings_get_boolean (_tmp3_, key);
#line 291 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp4_ = self->priv->categories_scroll;
#line 291 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_set_no_show_all ((GtkWidget*) _tmp4_, vis);
#line 292 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp5_ = self->priv->categories_scroll;
#line 292 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, vis);
#line 293 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->compact_mode = vis;
#line 294 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 295 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1327 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("menu-headers")))) {
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1333 "ListView.c"
			default:
			{
				gboolean hed = FALSE;
				GSettings* _tmp6_;
#line 297 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp6_ = self->priv->_settings;
#line 297 "../src/panel/applets/budgie-menu/views/ListView.vala"
				hed = g_settings_get_boolean (_tmp6_, key);
#line 298 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->headers_visible = hed;
#line 299 "../src/panel/applets/budgie-menu/views/ListView.vala"
				if (hed) {
#line 1346 "ListView.c"
					GtkListBox* _tmp7_;
#line 300 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp7_ = self->priv->applications;
#line 300 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_list_box_set_header_func (_tmp7_, _application_list_view_do_list_header_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
#line 1352 "ListView.c"
				} else {
					GtkListBox* _tmp8_;
#line 302 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp8_ = self->priv->applications;
#line 302 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_list_box_set_header_func (_tmp8_, NULL, NULL, NULL);
#line 1359 "ListView.c"
				}
#line 304 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 305 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1365 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("menu-categories-hover")))) {
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1371 "ListView.c"
			default:
			{
				GSettings* _tmp9_;
#line 308 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp9_ = self->priv->_settings;
#line 308 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->rollover_menus = g_settings_get_boolean (_tmp9_, key);
#line 309 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1381 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("menu-show-control-center-items")))) {
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1387 "ListView.c"
			default:
			{
				GSettings* _tmp10_;
#line 311 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp10_ = self->priv->_settings;
#line 311 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->show_control_center_panels = g_settings_get_boolean (_tmp10_, key);
#line 312 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 313 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1399 "ListView.c"
			}
		}
	} else {
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1405 "ListView.c"
			default:
			{
#line 316 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1410 "ListView.c"
			}
		}
	}
}

/**
 * Launches the application in the given row.
 */
static void
application_list_view_on_row_activate (ApplicationListView* self,
                                       GtkListBoxRow* row)
{
	MenuButton* btn = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	MenuButton* _tmp2_;
	BudgieApplication* _tmp3_;
	BudgieApplication* _tmp4_;
#line 323 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (row == NULL) {
#line 325 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1435 "ListView.c"
	}
#line 328 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
#line 328 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 328 "../src/panel/applets/budgie-menu/views/ListView.vala"
	btn = _tmp1_;
#line 329 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = btn;
#line 329 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = menu_button_get_app (_tmp2_);
#line 329 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = _tmp3_;
#line 329 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp4_);
#line 330 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 323 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (btn);
#line 1455 "ListView.c"
}

/**
 * Provide category headers in the "All" category
 */
static void
application_list_view_do_list_header (ApplicationListView* self,
                                      GtkListBoxRow* before,
                                      GtkListBoxRow* after)
{
	MenuButton* child = NULL;
	gchar* prev = NULL;
	gchar* next = NULL;
	BudgieCategory* _tmp0_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child = NULL;
#line 338 "../src/panel/applets/budgie-menu/views/ListView.vala"
	prev = NULL;
#line 339 "../src/panel/applets/budgie-menu/views/ListView.vala"
	next = NULL;
#line 342 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->current_category;
#line 342 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp0_ != NULL) {
#line 343 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (before != NULL) {
#line 344 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_list_box_row_set_header (before, NULL);
#line 1488 "ListView.c"
		}
#line 346 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (after != NULL) {
#line 347 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_list_box_row_set_header (after, NULL);
#line 1494 "ListView.c"
		}
#line 349 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (next);
#line 349 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (prev);
#line 349 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 349 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1504 "ListView.c"
	}
#line 353 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (before != NULL) {
#line 1508 "ListView.c"
		GtkWidget* _tmp1_;
		MenuButton* _tmp2_;
		MenuButton* _tmp3_;
		BudgieCategory* _tmp4_;
		BudgieCategory* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 354 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = gtk_bin_get_child ((GtkBin*) before);
#line 354 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp2_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp1_) ? ((MenuButton*) _tmp1_) : NULL);
#line 354 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 354 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child = _tmp2_;
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = child;
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = menu_button_get_category (_tmp3_);
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp5_ = _tmp4_;
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = budgie_category_get_name (_tmp5_);
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = _tmp6_;
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (prev);
#line 355 "../src/panel/applets/budgie-menu/views/ListView.vala"
		prev = _tmp8_;
#line 1541 "ListView.c"
	}
#line 358 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (after != NULL) {
#line 1545 "ListView.c"
		GtkWidget* _tmp9_;
		MenuButton* _tmp10_;
		MenuButton* _tmp11_;
		BudgieCategory* _tmp12_;
		BudgieCategory* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 359 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = gtk_bin_get_child ((GtkBin*) after);
#line 359 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp9_) ? ((MenuButton*) _tmp9_) : NULL);
#line 359 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 359 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child = _tmp10_;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_category (_tmp11_);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp14_ = budgie_category_get_name (_tmp13_);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp15_ = _tmp14_;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (next);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
		next = _tmp16_;
#line 1578 "ListView.c"
	}
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (before == NULL) {
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp18_ = TRUE;
#line 1584 "ListView.c"
	} else {
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp18_ = after == NULL;
#line 1588 "ListView.c"
	}
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp18_) {
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = TRUE;
#line 1594 "ListView.c"
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp19_ = prev;
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp20_ = next;
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = g_strcmp0 (_tmp19_, _tmp20_) != 0;
#line 1604 "ListView.c"
	}
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp17_) {
#line 1608 "ListView.c"
		GtkLabel* label = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GtkLabel* _tmp24_;
		GtkLabel* _tmp25_;
		GtkLabel* _tmp26_;
		GtkStyleContext* _tmp27_;
		GtkLabel* _tmp28_;
		GtkLabel* _tmp29_;
		GtkLabel* _tmp30_;
		GtkLabel* _tmp31_;
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp21_ = prev;
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp22_ = g_markup_printf_escaped ("<big>%s</big>", _tmp21_);
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp23_ = _tmp22_;
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp24_ = (GtkLabel*) gtk_label_new (_tmp23_);
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_ref_sink (_tmp24_);
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp25_ = _tmp24_;
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (_tmp23_);
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		label = _tmp25_;
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp26_ = label;
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_style_context_add_class (_tmp27_, "dim-label");
#line 367 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp28_ = label;
#line 367 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
#line 368 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp29_ = label;
#line 368 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_label_set_use_markup (_tmp29_, TRUE);
#line 369 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp30_ = label;
#line 369 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_list_box_row_set_header (before, (GtkWidget*) _tmp30_);
#line 370 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp31_ = label;
#line 370 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_set ((GtkWidget*) _tmp31_, "margin", 6, NULL);
#line 364 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (label);
#line 1661 "ListView.c"
	} else {
#line 372 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_list_box_row_set_header (before, NULL);
#line 1665 "ListView.c"
	}
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (next);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (prev);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child);
#line 1673 "ListView.c"
}

/**
 * Filter out results in the list according to whatever the current filter is,
 * i.e. group based or search based
 */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1698 "ListView.c"
}

static gboolean
application_list_view_do_filter_list (ApplicationListView* self,
                                      GtkListBoxRow* row)
{
	MenuButton* child = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	gchar* term = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkBox* _tmp14_;
	BudgieCategory* _tmp15_;
	MenuButton* _tmp18_;
	BudgieCategory* _tmp19_;
	BudgieCategory* _tmp20_;
	BudgieCategory* _tmp21_;
	MenuButton* _tmp22_;
	gboolean result;
#line 380 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 380 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 381 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
#line 381 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 381 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child = _tmp1_;
#line 384 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = application_view_get_search_term ((ApplicationView*) self);
#line 384 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _tmp2_;
#line 384 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 384 "../src/panel/applets/budgie-menu/views/ListView.vala"
	term = _tmp4_;
#line 385 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = term;
#line 385 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = strlen (_tmp5_);
#line 385 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = _tmp6_;
#line 385 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp7_ > 0) {
#line 1749 "ListView.c"
		GtkBox* _tmp8_;
		MenuButton* _tmp9_;
		BudgieRelevancyService* _tmp10_;
		MenuButton* _tmp11_;
		BudgieApplication* _tmp12_;
		BudgieApplication* _tmp13_;
#line 387 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = self->priv->categories;
#line 387 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = child;
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (application_view_is_item_dupe ((ApplicationView*) self, _tmp9_)) {
#line 390 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = FALSE;
#line 390 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 390 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 390 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1772 "ListView.c"
		}
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = ((ApplicationView*) self)->relevancy_service;
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child;
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_app (_tmp11_);
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = budgie_relevancy_service_is_app_relevant (_tmp10_, _tmp13_);
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 395 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1790 "ListView.c"
	}
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = self->priv->categories;
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
#line 402 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = self->priv->current_category;
#line 402 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp15_ == NULL) {
#line 1800 "ListView.c"
		MenuButton* _tmp16_;
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = child;
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (menu_button_is_control_center_panel (_tmp16_)) {
#line 406 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (!self->priv->show_control_center_panels) {
#line 407 "../src/panel/applets/budgie-menu/views/ListView.vala"
				result = FALSE;
#line 407 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_free0 (term);
#line 407 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child);
#line 407 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return result;
#line 1816 "ListView.c"
			}
		}
#line 411 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (self->priv->headers_visible) {
#line 413 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = TRUE;
#line 413 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 413 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 413 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1829 "ListView.c"
		} else {
			MenuButton* _tmp17_;
#line 417 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp17_ = child;
#line 417 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = !application_view_is_item_dupe ((ApplicationView*) self, _tmp17_);
#line 417 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 417 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 417 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1842 "ListView.c"
		}
	}
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = child;
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = menu_button_get_category (_tmp18_);
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp20_ = _tmp19_;
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp21_ = self->priv->current_category;
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp20_ != _tmp21_) {
#line 423 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = FALSE;
#line 423 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 423 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 423 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1863 "ListView.c"
	}
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp22_ = child;
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (menu_button_is_control_center_panel (_tmp22_)) {
#line 428 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (!self->priv->show_control_center_panels) {
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = FALSE;
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1879 "ListView.c"
		}
	}
#line 435 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = TRUE;
#line 435 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (term);
#line 435 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child);
#line 435 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 1890 "ListView.c"
}

/**
 * Sorts two list items.
 *
 * If there is an active search, items will be sorted by how well they match the term.
 * Otherwise, they will be sorted alphebetically by their name.
 */
static gint
application_list_view_do_sort_list (ApplicationListView* self,
                                    GtkListBoxRow* row1,
                                    GtkListBoxRow* row2)
{
	MenuButton* child1 = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	MenuButton* child2 = NULL;
	GtkWidget* _tmp2_;
	MenuButton* _tmp3_;
	gchar* term = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar* parentA = NULL;
	MenuButton* _tmp28_;
	BudgieCategory* _tmp29_;
	BudgieCategory* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* parentB = NULL;
	MenuButton* _tmp34_;
	BudgieCategory* _tmp35_;
	BudgieCategory* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gboolean _tmp40_ = FALSE;
	MenuButton* _tmp41_;
	BudgieCategory* _tmp42_;
	BudgieCategory* _tmp43_;
	MenuButton* _tmp44_;
	BudgieCategory* _tmp45_;
	BudgieCategory* _tmp46_;
	gchar* nameA = NULL;
	MenuButton* _tmp49_;
	BudgieApplication* _tmp50_;
	BudgieApplication* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* nameB = NULL;
	MenuButton* _tmp55_;
	BudgieApplication* _tmp56_;
	BudgieApplication* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gint result;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child1 = _tmp1_;
#line 446 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 446 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp2_) ? ((MenuButton*) _tmp2_) : NULL);
#line 446 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child2 = _tmp3_;
#line 448 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = application_view_get_search_term ((ApplicationView*) self);
#line 448 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = _tmp4_;
#line 448 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 448 "../src/panel/applets/budgie-menu/views/ListView.vala"
	term = _tmp6_;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = term;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = strlen (_tmp7_);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = _tmp8_;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp9_ > 0) {
#line 1989 "ListView.c"
		gint sc1 = 0;
		BudgieRelevancyService* _tmp10_;
		MenuButton* _tmp11_;
		BudgieApplication* _tmp12_;
		BudgieApplication* _tmp13_;
		gint sc2 = 0;
		BudgieRelevancyService* _tmp14_;
		MenuButton* _tmp15_;
		BudgieApplication* _tmp16_;
		BudgieApplication* _tmp17_;
#line 453 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = ((ApplicationView*) self)->relevancy_service;
#line 453 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child1;
#line 453 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_app (_tmp11_);
#line 453 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 453 "../src/panel/applets/budgie-menu/views/ListView.vala"
		sc1 = budgie_relevancy_service_get_score (_tmp10_, _tmp13_);
#line 454 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp14_ = ((ApplicationView*) self)->relevancy_service;
#line 454 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp15_ = child2;
#line 454 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = menu_button_get_app (_tmp15_);
#line 454 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = _tmp16_;
#line 454 "../src/panel/applets/budgie-menu/views/ListView.vala"
		sc2 = budgie_relevancy_service_get_score (_tmp14_, _tmp17_);
#line 457 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (sc1 < sc2) {
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = -1;
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child2);
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child1);
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 2032 "ListView.c"
		} else {
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (sc1 > sc2) {
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
				result = 1;
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_free0 (term);
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child2);
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child1);
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return result;
#line 2046 "ListView.c"
			} else {
				MenuButton* _tmp18_;
				BudgieApplication* _tmp19_;
				BudgieApplication* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				MenuButton* _tmp23_;
				BudgieApplication* _tmp24_;
				BudgieApplication* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp18_ = child1;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp19_ = menu_button_get_app (_tmp18_);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp20_ = _tmp19_;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp21_ = budgie_application_get_name (_tmp20_);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp22_ = _tmp21_;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp23_ = child2;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp24_ = menu_button_get_app (_tmp23_);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp25_ = _tmp24_;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp26_ = budgie_application_get_name (_tmp25_);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp27_ = _tmp26_;
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				result = g_utf8_collate (_tmp22_, _tmp27_);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_free0 (term);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child2);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child1);
#line 463 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return result;
#line 2088 "ListView.c"
			}
		}
	}
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp28_ = child1;
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp29_ = menu_button_get_category (_tmp28_);
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp30_ = _tmp29_;
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp31_ = budgie_category_get_name (_tmp30_);
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp32_ = _tmp31_;
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp33_ = budgie_relevancy_service_searchable_string (_tmp32_);
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parentA = _tmp33_;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp34_ = child2;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp35_ = menu_button_get_category (_tmp34_);
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp36_ = _tmp35_;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp37_ = budgie_category_get_name (_tmp36_);
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp38_ = _tmp37_;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp39_ = budgie_relevancy_service_searchable_string (_tmp38_);
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parentB = _tmp39_;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp41_ = child1;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp42_ = menu_button_get_category (_tmp41_);
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp43_ = _tmp42_;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp44_ = child2;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp45_ = menu_button_get_category (_tmp44_);
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp46_ = _tmp45_;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp43_ != _tmp46_) {
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp40_ = self->priv->headers_visible;
#line 2136 "ListView.c"
	} else {
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp40_ = FALSE;
#line 2140 "ListView.c"
	}
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp40_) {
#line 2144 "ListView.c"
		const gchar* _tmp47_;
		const gchar* _tmp48_;
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp47_ = parentA;
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp48_ = parentB;
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = g_utf8_collate (_tmp47_, _tmp48_);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (parentB);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (parentA);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child2);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child1);
#line 471 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 2165 "ListView.c"
	}
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp49_ = child1;
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp50_ = menu_button_get_app (_tmp49_);
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp51_ = _tmp50_;
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp52_ = budgie_application_get_name (_tmp51_);
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp53_ = _tmp52_;
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp54_ = budgie_relevancy_service_searchable_string (_tmp53_);
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	nameA = _tmp54_;
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp55_ = child2;
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp56_ = menu_button_get_app (_tmp55_);
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp57_ = _tmp56_;
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp58_ = budgie_application_get_name (_tmp57_);
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp59_ = _tmp58_;
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp60_ = budgie_relevancy_service_searchable_string (_tmp59_);
#line 476 "../src/panel/applets/budgie-menu/views/ListView.vala"
	nameB = _tmp60_;
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp61_ = nameA;
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp62_ = nameB;
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = g_utf8_collate (_tmp61_, _tmp62_);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (nameB);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (nameA);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (parentB);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (parentA);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (term);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child2);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child1);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2217 "ListView.c"
}

/**
 * Change the current group/category
 */
static void
application_list_view_update_category (ApplicationListView* self,
                                       CategoryButton* btn)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 483 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 483 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (btn != NULL);
#line 484 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) btn);
#line 484 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _tmp0_;
#line 484 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp1_) {
#line 2239 "ListView.c"
		BudgieCategory* _tmp2_;
		BudgieCategory* _tmp3_;
		BudgieCategory* _tmp4_;
#line 485 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp2_ = category_button_get_category (btn);
#line 485 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = _tmp2_;
#line 485 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 485 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self->priv->current_category);
#line 485 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self->priv->current_category = _tmp4_;
#line 486 "../src/panel/applets/budgie-menu/views/ListView.vala"
		application_view_invalidate ((ApplicationView*) self);
#line 2255 "ListView.c"
	}
}

/**
 * We need to make some changes to our display before we go showing ourselves
 * again! :)
 */
static void
application_list_view_real_on_show (ApplicationView* base)
{
	ApplicationListView * self;
	CategoryButton* _tmp0_;
	CategoryButton* _tmp1_;
	GtkListBox* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkAdjustment* _tmp6_;
	GtkBox* _tmp7_;
#line 494 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 495 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 495 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 496 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->all_categories;
#line 496 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp1_);
#line 498 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->applications;
#line 498 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_select_row (_tmp2_, NULL);
#line 499 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->content_scroll;
#line 499 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment (_tmp3_);
#line 499 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_adjustment_set_value (_tmp4_, (gdouble) 0);
#line 500 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->categories_scroll;
#line 500 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = gtk_scrolled_window_get_vadjustment (_tmp5_);
#line 500 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_adjustment_set_value (_tmp6_, (gdouble) 0);
#line 501 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = self->priv->categories;
#line 501 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 503 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!self->priv->compact_mode) {
#line 2307 "ListView.c"
		GtkScrolledWindow* _tmp8_;
#line 504 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = self->priv->categories_scroll;
#line 504 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 2313 "ListView.c"
	} else {
		GtkScrolledWindow* _tmp9_;
#line 506 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = self->priv->categories_scroll;
#line 506 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 2320 "ListView.c"
	}
}

GSettings*
application_list_view_get_settings (ApplicationListView* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->_settings;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = _tmp0_;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2337 "ListView.c"
}

static void
application_list_view_set_settings (ApplicationListView* self,
                                    GSettings* value)
{
	GSettings* old_value;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	old_value = application_list_view_get_settings (self);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (old_value != value) {
#line 2351 "ListView.c"
		GSettings* _tmp0_;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self->priv->_settings);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self->priv->_settings = _tmp0_;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, application_list_view_properties[APPLICATION_LIST_VIEW_SETTINGS_PROPERTY]);
#line 2361 "ListView.c"
	}
}

static void
_application_list_view___lambda12_ (ApplicationListView* self)
{
#line 64 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_set_scaled_sizing (self);
#line 2370 "ListView.c"
}

static void
__application_list_view___lambda12__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 63 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_application_list_view___lambda12_ ((ApplicationListView*) self);
#line 2380 "ListView.c"
}

static void
_application_list_view___lambda13_ (ApplicationListView* self)
{
	CategoryButton* _tmp0_;
#line 84 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 84 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 2391 "ListView.c"
}

static void
__application_list_view___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                               gpointer self)
{
#line 83 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_application_list_view___lambda13_ ((ApplicationListView*) self);
#line 2400 "ListView.c"
}

static void
_application_list_view_on_row_activate_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_row_activate ((ApplicationListView*) self, row);
#line 2410 "ListView.c"
}

static void
_application_list_view_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 119 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed ((ApplicationListView*) self, key);
#line 2420 "ListView.c"
}

static gboolean
_application_list_view_do_filter_list_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                gpointer self)
{
	gboolean result;
	result = application_list_view_do_filter_list ((ApplicationListView*) self, row);
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2431 "ListView.c"
}

static gint
_application_list_view_do_sort_list_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                            GtkListBoxRow* row2,
                                                            gpointer self)
{
	gint result;
	result = application_list_view_do_sort_list ((ApplicationListView*) self, row1, row2);
#line 127 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2443 "ListView.c"
}

static GObject *
application_list_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ApplicationListView * self;
	GSettings* _tmp0_;
	GtkBox* _tmp1_ = NULL;
	GtkScrolledWindow* _tmp2_ = NULL;
	GtkScrolledWindow* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkScrolledWindow* _tmp7_;
	GtkBox* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	CategoryButton* _tmp10_;
	CategoryButton* _tmp11_;
	CategoryButton* _tmp12_;
	GtkBox* _tmp13_;
	CategoryButton* _tmp14_;
	GtkBox* right_layout = NULL;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkListBox* _tmp17_ = NULL;
	GtkListBox* _tmp18_;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkListBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkScrolledWindow* _tmp24_;
	GtkLabel* placeholder = NULL;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkLabel* _tmp31_;
	GtkListBox* _tmp32_;
	GtkLabel* _tmp33_;
	GSettings* _tmp34_;
	GtkListBox* _tmp35_;
	GtkListBox* _tmp36_;
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parent_class = G_OBJECT_CLASS (application_list_view_parent_class);
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 55 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, self->priv->SCALED_WIDTH, self->priv->SCALED_HEIGHT);
#line 56 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->_settings;
#line 56 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_view_set_icon_size ((ApplicationView*) self, g_settings_get_int (_tmp0_, "menu-icons-size"));
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 3);
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 3);
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp1_);
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories);
#line 58 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->categories = _tmp1_;
#line 63 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GObject*) self, "notify::scale-factor", (GCallback) __application_list_view___lambda12__g_object_notify, self, 0);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp2_, FALSE);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_shadow_type (_tmp2_, GTK_SHADOW_NONE);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp2_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp2_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp2_, self->priv->SCALED_HEIGHT);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp2_, TRUE);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp2_);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories_scroll);
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->categories_scroll = _tmp2_;
#line 75 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->categories_scroll;
#line 75 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 75 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp4_, "categories");
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->categories_scroll;
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp6_, "sidebar");
#line 77 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = self->priv->categories_scroll;
#line 77 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = self->priv->categories;
#line 77 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 78 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = self->priv->categories_scroll;
#line 78 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp9_, FALSE, FALSE, (guint) 0);
#line 81 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp10_ = category_button_new (NULL);
#line 81 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp10_);
#line 81 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 81 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->all_categories = _tmp10_;
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp11_ = self->priv->all_categories;
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 83 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp12_ = self->priv->all_categories;
#line 83 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp12_, "toggled", (GCallback) __application_list_view___lambda13__gtk_toggle_button_toggled, self, 0);
#line 86 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp13_ = self->priv->categories;
#line 86 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = self->priv->all_categories;
#line 86 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, TRUE, (guint) 0);
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp15_);
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	right_layout = _tmp15_;
#line 89 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp16_ = right_layout;
#line 89 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_selection_mode (_tmp17_, GTK_SELECTION_SINGLE);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set ((GtkWidget*) _tmp17_, "height-request", self->priv->SCALED_HEIGHT, NULL);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp17_);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->applications);
#line 92 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->applications = _tmp17_;
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = self->priv->applications;
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object (_tmp18_, "row-activated", (GCallback) _application_list_view_on_row_activate_gtk_list_box_row_activated, self, 0);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp19_, TRUE);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp19_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp19_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp19_, self->priv->SCALED_HEIGHT);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp19_);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->content_scroll);
#line 100 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->content_scroll = _tmp19_;
#line 106 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp20_ = self->priv->content_scroll;
#line 106 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp20_, TRUE);
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp21_ = self->priv->content_scroll;
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp22_ = self->priv->applications;
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 108 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp23_ = right_layout;
#line 108 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp24_ = self->priv->content_scroll;
#line 108 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp23_, (GtkWidget*) _tmp24_, TRUE, TRUE, (guint) 0);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp25_ = g_strdup_printf ("<big>%s</big>", _ ("Sorry, no items found"));
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp26_ = _tmp25_;
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_label_set_use_markup (_tmp27_, TRUE);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp27_);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp28_ = _tmp27_;
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (_tmp26_);
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	placeholder = _tmp28_;
#line 115 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp29_ = placeholder;
#line 115 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _tmp29_);
#line 115 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp30_, "dim-label");
#line 116 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp31_ = placeholder;
#line 116 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp32_ = self->priv->applications;
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp33_ = placeholder;
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_placeholder (_tmp32_, (GtkWidget*) _tmp33_);
#line 119 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp34_ = self->priv->_settings;
#line 119 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object (_tmp34_, "changed", (GCallback) _application_list_view_on_settings_changed_g_settings_changed, self, 0);
#line 120 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-compact");
#line 121 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-headers");
#line 122 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-categories-hover");
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-show-control-center-items");
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp35_ = self->priv->applications;
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_filter_func (_tmp35_, _application_list_view_do_filter_list_gtk_list_box_filter_func, g_object_ref (self), g_object_unref);
#line 127 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp36_ = self->priv->applications;
#line 127 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_sort_func (_tmp36_, _application_list_view_do_sort_list_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 129 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_set_scaled_sizing (self);
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (placeholder);
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (right_layout);
#line 54 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return obj;
#line 2705 "ListView.c"
}

static void
application_list_view_class_init (ApplicationListViewClass * klass,
                                  gpointer klass_data)
{
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationListView_private_offset);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->refresh = (void (*) (ApplicationView*, BudgieAppIndex*)) application_list_view_real_refresh;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->invalidate = (void (*) (ApplicationView*)) application_list_view_real_invalidate;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->on_search_entry_activated = (void (*) (ApplicationView*)) application_list_view_real_on_search_entry_activated;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->on_show = (void (*) (ApplicationView*)) application_list_view_real_on_show;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_list_view_get_property;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_list_view_set_property;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->constructor = application_list_view_constructor;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->finalize = application_list_view_finalize;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_LIST_VIEW_SETTINGS_PROPERTY, application_list_view_properties[APPLICATION_LIST_VIEW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2734 "ListView.c"
}

static void
application_list_view_instance_init (ApplicationListView * self,
                                     gpointer klass)
{
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv = application_list_view_get_instance_private (self);
#line 21 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_HEIGHT = APPLICATION_LIST_VIEW_HEIGHT;
#line 22 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->SCALED_WIDTH = APPLICATION_LIST_VIEW_WIDTH;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->_settings = NULL;
#line 33 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->current_category = NULL;
#line 39 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->rollover_menus = TRUE;
#line 41 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_rec_mutex_init (&self->priv->__lock_reloading);
#line 41 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->reloading = FALSE;
#line 2757 "ListView.c"
}

static void
application_list_view_finalize (GObject * obj)
{
	ApplicationListView * self;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 24 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories);
#line 25 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->applications);
#line 26 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories_scroll);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->content_scroll);
#line 28 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->_settings);
#line 33 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->current_category);
#line 41 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_rec_mutex_clear (&self->priv->__lock_reloading);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (application_list_view_parent_class)->finalize (obj);
#line 2784 "ListView.c"
}

/**
 * Widget to display applications in a list.
 *
 * This shows a list of categories on the left, and all applications
 * on the right.
 */
GType
application_list_view_get_type (void)
{
	return application_list_view_type_id;
}

GType
application_list_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationListView), 0, (GInstanceInitFunc) application_list_view_instance_init, NULL };
	application_list_view_type_id = g_type_module_register_type (module, TYPE_APPLICATION_VIEW, "ApplicationListView", &g_define_type_info, 0);
	ApplicationListView_private_offset = sizeof (ApplicationListViewPrivate);
	return application_list_view_type_id;
}

static void
_vala_application_list_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ApplicationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	switch (property_id) {
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		case APPLICATION_LIST_VIEW_SETTINGS_PROPERTY:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_value_set_object (value, application_list_view_get_settings (self));
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2824 "ListView.c"
		default:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2830 "ListView.c"
	}
}

static void
_vala_application_list_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	ApplicationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	switch (property_id) {
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		case APPLICATION_LIST_VIEW_SETTINGS_PROPERTY:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		application_list_view_set_settings (self, g_value_get_object (value));
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2850 "ListView.c"
		default:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2856 "ListView.c"
	}
}

