/* BluetoothIndicator.c generated by valac 0.56.17, the Vala compiler
 * generated from BluetoothIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 * Copyright © 2015 Alberts Muktupāvels
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BluetoothIndicator is largely inspired by gnome-flashback.
 */

#include "statusapplet.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include "plugin.h"
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <upower.h>
#include <pango/pango.h>
#include <math.h>
#include <float.h>

#define BT_DEVICE_ROW_OBEX_AGENT "org.bluez.obex.Agent1"
#define BT_DEVICE_ROW_OBEX_PATH "/org/bluez/obex/budgie"
#define BT_DEVICE_ROW_SMARTPHONE_MASK ((guint32) 0x20C)
#define BT_DEVICE_ROW_DESKTOP_MASK ((guint32) 0x104)
#define BT_DEVICE_ROW_LAPTOP_MASK ((guint32) 0x10C)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_BLUETOOTH_CLIENT (bluetooth_client_get_type ())
#define BLUETOOTH_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH_CLIENT, BluetoothClient))
#define BLUETOOTH_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLUETOOTH_CLIENT, BluetoothClientClass))
#define IS_BLUETOOTH_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH_CLIENT))
#define IS_BLUETOOTH_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLUETOOTH_CLIENT))
#define BLUETOOTH_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLUETOOTH_CLIENT, BluetoothClientClass))

typedef struct _BluetoothClient BluetoothClient;
typedef struct _BluetoothClientClass BluetoothClientClass;
enum  {
	BLUETOOTH_INDICATOR_0_PROPERTY,
	BLUETOOTH_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* bluetooth_indicator_properties[BLUETOOTH_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
enum  {
	BT_DEVICE_ROW_0_PROPERTY,
	BT_DEVICE_ROW_DEVICE_PROPERTY,
	BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY,
	BT_DEVICE_ROW_UP_DEVICE_PROPERTY,
	BT_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bt_device_row_properties[BT_DEVICE_ROW_NUM_PROPERTIES];
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _BtDeviceRowToggleConnectionData BtDeviceRowToggleConnectionData;
enum  {
	BT_DEVICE_ROW_PROPERTIES_UPDATED_SIGNAL,
	BT_DEVICE_ROW_NUM_SIGNALS
};
static guint bt_device_row_signals[BT_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothIndicatorPrivate {
	GtkListBox* devices_box;
	GtkSwitch* bluetooth_switch;
	GtkLabel* placeholder_label;
	GtkLabel* placeholder_sublabel;
	BluetoothClient* client;
	ObexManager* obex_manager;
	gulong switch_handler_id;
};

struct _Block8Data {
	int _ref_count_;
	BluetoothIndicator* self;
	Device1* device;
};

struct _Block9Data {
	int _ref_count_;
	BluetoothIndicator* self;
	UpDevice* up_device;
};

struct _Block10Data {
	int _ref_count_;
	BluetoothIndicator* self;
	gchar* path;
};

struct _BTDeviceRowPrivate {
	GtkImage* image;
	GtkLabel* name_label;
	GtkRevealer* battery_revealer;
	GtkImage* battery_icon;
	GtkLabel* battery_label;
	GtkRevealer* revealer;
	GtkSpinner* spinner;
	GtkLabel* status_label;
	GtkButton* send_button;
	GtkButton* connection_button;
	GtkRevealer* progress_revealer;
	GtkLabel* file_label;
	GtkLabel* progress_label;
	GtkProgressBar* progress_bar;
	Device1* _device;
	ObexManager* _obex_manager;
	gulong up_handler_id;
	UpDevice* _up_device;
};

struct _BtDeviceRowToggleConnectionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BTDeviceRow* self;
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GDBusConnection* conn;
	GDBusConnection* _tmp3_;
	GDBusConnection* _tmp4_;
	Transfer* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GError* e;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GtkSpinner* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkSpinner* _tmp18_;
	GtkRevealer* _tmp19_;
	Device1* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GtkLabel* _tmp23_;
	Device1* _tmp24_;
	GtkLabel* _tmp25_;
	Device1* _tmp26_;
	GError* _vala1_e;
	Device1* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	Device1* _tmp34_;
	gboolean _tmp35_;
	gboolean _tmp36_;
	GtkLabel* _tmp37_;
	GtkRevealer* _tmp38_;
	GtkSpinner* _tmp39_;
	GError* _inner_error0_;
};

static gint BluetoothIndicator_private_offset;
static gpointer bluetooth_indicator_parent_class = NULL;
static GType bluetooth_indicator_type_id = 0;
static gint BTDeviceRow_private_offset;
static gpointer bt_device_row_parent_class = NULL;
static GType bt_device_row_type_id = 0;

GType bluetooth_client_register_type (GTypeModule * module);
VALA_EXTERN GType bluetooth_client_get_type (void) G_GNUC_CONST ;
static gboolean bluetooth_indicator_on_button_released (BluetoothIndicator* self,
                                                 GdkEventButton* e);
VALA_EXTERN gboolean bluetooth_client_airplane_mode_enabled (BluetoothClient* self);
VALA_EXTERN void bluetooth_client_set_airplane_mode (BluetoothClient* self,
                                         gboolean enabled);
static void bluetooth_indicator_on_settings_activate (BluetoothIndicator* self);
static void bluetooth_indicator_on_switch_activate (BluetoothIndicator* self);
static void bluetooth_indicator_add_device (BluetoothIndicator* self,
                                     Device1* device);
static void __lambda22_ (BluetoothIndicator* self);
static void ___lambda22__bt_device_row_properties_updated (BTDeviceRow* _sender,
                                                    gpointer self);
static void bluetooth_indicator_remove_device (BluetoothIndicator* self,
                                        Device1* device);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda23_ (Block8Data* _data8_,
                  GtkWidget* row);
static void ___lambda23__gtk_callback (GtkWidget* widget,
                                gpointer self);
static gint bluetooth_indicator_sort_devices (BluetoothIndicator* self,
                                       GtkListBoxRow* a,
                                       GtkListBoxRow* b);
static gboolean bluetooth_indicator_filter_paired_devices (BluetoothIndicator* self,
                                                    GtkListBoxRow* row);
static void bluetooth_indicator_update_state_ui (BluetoothIndicator* self);
static GObject * bluetooth_indicator_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static gboolean _bluetooth_indicator_on_button_released_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                  GdkEventButton* event,
                                                                                  gpointer self);
VALA_EXTERN BluetoothClient* bluetooth_client_new (void);
VALA_EXTERN BluetoothClient* bluetooth_client_construct (GType object_type);
static void _bluetooth_indicator___lambda24_ (BluetoothIndicator* self,
                                       Device1* device);
static void __bluetooth_indicator___lambda24__bluetooth_client_device_added (BluetoothClient* _sender,
                                                                      Device1* device,
                                                                      gpointer self);
static void _bluetooth_indicator___lambda25_ (BluetoothIndicator* self,
                                       Device1* device);
static void __bluetooth_indicator___lambda25__bluetooth_client_device_removed (BluetoothClient* _sender,
                                                                        Device1* device,
                                                                        gpointer self);
static void _bluetooth_indicator___lambda26_ (BluetoothIndicator* self,
                                       UpDevice* up_device);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda27_ (Block9Data* _data9_,
                  GtkWidget* row);
static void ___lambda27__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void __bluetooth_indicator___lambda26__bluetooth_client_upower_device_added (BluetoothClient* _sender,
                                                                             UpDevice* up_device,
                                                                             gpointer self);
static void _bluetooth_indicator___lambda28_ (BluetoothIndicator* self,
                                       const gchar* path);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda29_ (Block10Data* _data10_,
                  GtkWidget* row);
static void ___lambda29__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void __bluetooth_indicator___lambda28__bluetooth_client_upower_device_removed (BluetoothClient* _sender,
                                                                               const gchar* object_path,
                                                                               gpointer self);
static void _bluetooth_indicator_update_state_ui_bluetooth_client_airplane_mode_changed (BluetoothClient* _sender,
                                                                                  gpointer self);
static void _bluetooth_indicator___lambda30_ (BluetoothIndicator* self);
VALA_EXTERN gboolean bluetooth_client_get_has_adapter (BluetoothClient* self);
static void __bluetooth_indicator___lambda30__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _bluetooth_indicator_on_settings_activate_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _bluetooth_indicator_on_switch_activate_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static gboolean _bluetooth_indicator_filter_paired_devices_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                              gpointer self);
static gint _bluetooth_indicator_sort_devices_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                               GtkListBoxRow* row2,
                                                               gpointer self);
static void _bluetooth_indicator___lambda31_ (BluetoothIndicator* self,
                                       GtkListBoxRow* row);
static void __bluetooth_indicator___lambda31__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void bluetooth_indicator_finalize (GObject * obj);
static void bt_device_row_hide_progress_revealer (BTDeviceRow* self);
static void bt_device_row_toggle_connection_data_free (gpointer _data);
static gboolean bt_device_row_toggle_connection_co (BtDeviceRowToggleConnectionData* _data_);
static void bt_device_row_toggle_connection_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void bt_device_row_transfer_active (BTDeviceRow* self,
                                    const gchar* address);
static void bt_device_row_update_transfer_progress (BTDeviceRow* self);
static void bt_device_row_transfer_added (BTDeviceRow* self,
                                   const gchar* address,
                                   Transfer* transfer);
static void bt_device_row_transfer_removed (BTDeviceRow* self,
                                     Transfer* transfer);
static void bt_device_row_update_battery (BTDeviceRow* self);
static void bt_device_row_update_status (BTDeviceRow* self);
static void _bt_device_row_up_device___lambda19_ (BTDeviceRow* self);
static void __bt_device_row_up_device___lambda19__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static GObject * bt_device_row_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _bt_device_row_transfer_active_obex_manager_transfer_active (ObexManager* _sender,
                                                                  const gchar* address,
                                                                  gpointer self);
static void _bt_device_row_transfer_added_obex_manager_transfer_added (ObexManager* _sender,
                                                                const gchar* address,
                                                                Transfer* transfer,
                                                                gpointer self);
static void _bt_device_row_transfer_removed_obex_manager_transfer_removed (ObexManager* _sender,
                                                                    Transfer* transfer,
                                                                    gpointer self);
static void _bt_device_row___lambda20_ (BTDeviceRow* self);
static void __bt_device_row___lambda20__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void _bt_device_row___lambda21_ (BTDeviceRow* self);
static void __bt_device_row___lambda21__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void _bt_device_row_update_status_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                     GVariant* changed_properties,
                                                                     gchar** invalidated_properties,
                                                                     gpointer self);
static void bt_device_row_finalize (GObject * obj);
static void _vala_bt_device_row_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_bt_device_row_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
bluetooth_indicator_get_instance_private (BluetoothIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothIndicator_private_offset);
}

static gboolean
bluetooth_indicator_on_button_released (BluetoothIndicator* self,
                                        GdkEventButton* e)
{
	gboolean enabled = FALSE;
	BluetoothClient* _tmp0_;
	BluetoothClient* _tmp1_;
	gboolean result;
#line 187 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 187 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 188 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (e->button != ((guint) GDK_BUTTON_MIDDLE)) {
#line 188 "../src/panel/applets/status/BluetoothIndicator.vala"
		result = GDK_EVENT_PROPAGATE;
#line 188 "../src/panel/applets/status/BluetoothIndicator.vala"
		return result;
#line 371 "BluetoothIndicator.c"
	}
#line 191 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->client;
#line 191 "../src/panel/applets/status/BluetoothIndicator.vala"
	enabled = bluetooth_client_airplane_mode_enabled (_tmp0_);
#line 192 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->client;
#line 192 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_client_set_airplane_mode (_tmp1_, !enabled);
#line 194 "../src/panel/applets/status/BluetoothIndicator.vala"
	result = GDK_EVENT_STOP;
#line 194 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 385 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_on_settings_activate (BluetoothIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 197 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->popover;
#line 198 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 200 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-bluetooth-panel.desktop");
#line 200 "../src/panel/applets/status/BluetoothIndicator.vala"
	app_info = _tmp1_;
#line 201 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = app_info;
#line 201 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp2_ == NULL) {
#line 201 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (app_info);
#line 201 "../src/panel/applets/status/BluetoothIndicator.vala"
		return;
#line 414 "BluetoothIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 204 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp3_ = app_info;
#line 204 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 204 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "BluetoothIndicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		e = _inner_error0_;
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		_inner_error0_ = NULL;
#line 206 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp4_ = e;
#line 206 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 206 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_warning ("BluetoothIndicator.vala:206: Unable to launch budgie-bluetooth-panel.d" \
"esktop: %s", _tmp5_);
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (e);
#line 446 "BluetoothIndicator.c"
	}
	__finally0:
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (app_info);
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 203 "../src/panel/applets/status/BluetoothIndicator.vala"
		return;
#line 459 "BluetoothIndicator.c"
	}
#line 197 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (app_info);
#line 463 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_on_switch_activate (BluetoothIndicator* self)
{
	gboolean active = FALSE;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothClient* _tmp3_;
#line 210 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->bluetooth_switch;
#line 212 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 212 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 212 "../src/panel/applets/status/BluetoothIndicator.vala"
	active = _tmp2_;
#line 213 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->priv->client;
#line 213 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_client_set_airplane_mode (_tmp3_, !active);
#line 488 "BluetoothIndicator.c"
}

static void
__lambda22_ (BluetoothIndicator* self)
{
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
#line 222 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->devices_box;
#line 222 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_filter (_tmp0_);
#line 223 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->devices_box;
#line 223 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_sort (_tmp1_);
#line 504 "BluetoothIndicator.c"
}

static void
___lambda22__bt_device_row_properties_updated (BTDeviceRow* _sender,
                                               gpointer self)
{
#line 221 "../src/panel/applets/status/BluetoothIndicator.vala"
	__lambda22_ ((BluetoothIndicator*) self);
#line 513 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_add_device (BluetoothIndicator* self,
                                Device1* device)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	BTDeviceRow* widget = NULL;
	ObexManager* _tmp3_;
	BTDeviceRow* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBox* _tmp7_;
#line 216 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (device != NULL);
#line 217 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = device1_get_alias (device);
#line 217 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = _tmp0_;
#line 217 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 217 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_debug ("BluetoothIndicator.vala:217: Bluetooth device added: %s", _tmp2_);
#line 217 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp2_);
#line 219 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->priv->obex_manager;
#line 219 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = bt_device_row_new (device, _tmp3_);
#line 219 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp4_);
#line 219 "../src/panel/applets/status/BluetoothIndicator.vala"
	widget = _tmp4_;
#line 221 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (widget, "properties-updated", (GCallback) ___lambda22__bt_device_row_properties_updated, self, 0);
#line 226 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = self->priv->devices_box;
#line 226 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) widget);
#line 227 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = self->priv->devices_box;
#line 227 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_filter (_tmp6_);
#line 228 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = self->priv->devices_box;
#line 228 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_sort (_tmp7_);
#line 216 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (widget);
#line 567 "BluetoothIndicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 575 "BluetoothIndicator.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	return _data8_;
#line 585 "BluetoothIndicator.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 595 "BluetoothIndicator.c"
		BluetoothIndicator* self;
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
		self = _data8_->self;
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (_data8_->device);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_slice_free (Block8Data, _data8_);
#line 605 "BluetoothIndicator.c"
	}
}

static void
__lambda23_ (Block8Data* _data8_,
             GtkWidget* row)
{
	BluetoothIndicator* self;
	BTDeviceRow* child = NULL;
	BTDeviceRow* _tmp0_;
	BTDeviceRow* _tmp1_;
	Device1* _tmp2_;
	Device1* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_;
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = _data8_->self;
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (row != NULL);
#line 235 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (IS_BT_DEVICE_ROW (row) ? ((BTDeviceRow*) row) : NULL);
#line 235 "../src/panel/applets/status/BluetoothIndicator.vala"
	child = _tmp0_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = child;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = bt_device_row_get_device (_tmp1_);
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = device1_get_address (_tmp3_);
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = _tmp4_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = _tmp5_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = device1_get_address (_data8_->device);
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = _tmp7_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp9_ = _tmp8_;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp10_ = g_strcmp0 (_tmp6_, _tmp9_) == 0;
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp9_);
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp6_);
#line 236 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp10_) {
#line 237 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_destroy (row);
#line 662 "BluetoothIndicator.c"
	}
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (child);
#line 666 "BluetoothIndicator.c"
}

static void
___lambda23__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	__lambda23_ (self, widget);
#line 675 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_remove_device (BluetoothIndicator* self,
                                   Device1* device)
{
	Block8Data* _data8_;
	Device1* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (device != NULL);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data8_->_ref_count_ = 1;
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data8_->self = g_object_ref (self);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (_data8_->device);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data8_->device = _tmp0_;
#line 232 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = device1_get_alias (_data8_->device);
#line 232 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 232 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 232 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_debug ("BluetoothIndicator.vala:232: Bluetooth device removed: %s", _tmp3_);
#line 232 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp3_);
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->priv->devices_box;
#line 234 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_foreach ((GtkContainer*) _tmp4_, ___lambda23__gtk_callback, _data8_);
#line 241 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = self->priv->devices_box;
#line 241 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_filter (_tmp5_);
#line 242 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = self->priv->devices_box;
#line 242 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_sort (_tmp6_);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	block8_data_unref (_data8_);
#line 231 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data8_ = NULL;
#line 732 "BluetoothIndicator.c"
}

/**
 * Sorts items based on their names and connection status.
 *
 * Items are sorted alphabetically, with connected devices at the top of the list.
 */
static gint
bluetooth_indicator_sort_devices (BluetoothIndicator* self,
                                  GtkListBoxRow* a,
                                  GtkListBoxRow* b)
{
	BTDeviceRow* a_device = NULL;
	BTDeviceRow* _tmp0_;
	BTDeviceRow* b_device = NULL;
	BTDeviceRow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	BTDeviceRow* _tmp3_;
	Device1* _tmp4_;
	Device1* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gint result;
#line 250 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 250 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 250 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 251 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (IS_BT_DEVICE_ROW (a) ? ((BTDeviceRow*) a) : NULL);
#line 251 "../src/panel/applets/status/BluetoothIndicator.vala"
	a_device = _tmp0_;
#line 252 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = _g_object_ref0 (IS_BT_DEVICE_ROW (b) ? ((BTDeviceRow*) b) : NULL);
#line 252 "../src/panel/applets/status/BluetoothIndicator.vala"
	b_device = _tmp1_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = a_device;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = bt_device_row_get_device (_tmp3_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = _tmp4_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = device1_get_connected (_tmp5_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = _tmp6_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp7_) {
#line 782 "BluetoothIndicator.c"
		BTDeviceRow* _tmp8_;
		Device1* _tmp9_;
		Device1* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp8_ = b_device;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp9_ = bt_device_row_get_device (_tmp8_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp10_ = _tmp9_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp11_ = device1_get_connected (_tmp10_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp12_ = _tmp11_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp2_ = _tmp12_;
#line 800 "BluetoothIndicator.c"
	} else {
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp2_ = FALSE;
#line 804 "BluetoothIndicator.c"
	}
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp2_) {
#line 808 "BluetoothIndicator.c"
		GCompareFunc _tmp13_;
		BTDeviceRow* _tmp14_;
		Device1* _tmp15_;
		Device1* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		BTDeviceRow* _tmp20_;
		Device1* _tmp21_;
		Device1* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gint _tmp26_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp13_ = ((GCompareFunc) g_strcmp0);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp14_ = a_device;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp15_ = bt_device_row_get_device (_tmp14_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp16_ = _tmp15_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp17_ = device1_get_alias (_tmp16_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp18_ = _tmp17_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp19_ = _tmp18_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp20_ = b_device;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp21_ = bt_device_row_get_device (_tmp20_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp22_ = _tmp21_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp23_ = device1_get_alias (_tmp22_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp24_ = _tmp23_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp25_ = _tmp24_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp26_ = _tmp13_ (_tmp19_, _tmp25_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_tmp25_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_tmp19_);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		result = _tmp26_;
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (b_device);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (a_device);
#line 254 "../src/panel/applets/status/BluetoothIndicator.vala"
		return result;
#line 863 "BluetoothIndicator.c"
	} else {
		BTDeviceRow* _tmp27_;
		Device1* _tmp28_;
		Device1* _tmp29_;
		gboolean _tmp30_;
		gboolean _tmp31_;
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp27_ = a_device;
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp28_ = bt_device_row_get_device (_tmp27_);
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp29_ = _tmp28_;
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp30_ = device1_get_connected (_tmp29_);
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp31_ = _tmp30_;
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_tmp31_) {
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
			result = -1;
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_object_unref0 (b_device);
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_object_unref0 (a_device);
#line 255 "../src/panel/applets/status/BluetoothIndicator.vala"
			return result;
#line 890 "BluetoothIndicator.c"
		} else {
			BTDeviceRow* _tmp32_;
			Device1* _tmp33_;
			Device1* _tmp34_;
			gboolean _tmp35_;
			gboolean _tmp36_;
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp32_ = b_device;
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp33_ = bt_device_row_get_device (_tmp32_);
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp34_ = _tmp33_;
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp35_ = device1_get_connected (_tmp34_);
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp36_ = _tmp35_;
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (_tmp36_) {
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
				result = 1;
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_object_unref0 (b_device);
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_object_unref0 (a_device);
#line 256 "../src/panel/applets/status/BluetoothIndicator.vala"
				return result;
#line 917 "BluetoothIndicator.c"
			} else {
				GCompareFunc _tmp37_;
				BTDeviceRow* _tmp38_;
				Device1* _tmp39_;
				Device1* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				BTDeviceRow* _tmp44_;
				Device1* _tmp45_;
				Device1* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gint _tmp50_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp37_ = ((GCompareFunc) g_strcmp0);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp38_ = a_device;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp39_ = bt_device_row_get_device (_tmp38_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp40_ = _tmp39_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp41_ = device1_get_alias (_tmp40_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp42_ = _tmp41_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp43_ = _tmp42_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp44_ = b_device;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp45_ = bt_device_row_get_device (_tmp44_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp46_ = _tmp45_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp47_ = device1_get_alias (_tmp46_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp48_ = _tmp47_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp49_ = _tmp48_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp50_ = _tmp37_ (_tmp43_, _tmp49_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_free0 (_tmp49_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_free0 (_tmp43_);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				result = _tmp50_;
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_object_unref0 (b_device);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_object_unref0 (a_device);
#line 257 "../src/panel/applets/status/BluetoothIndicator.vala"
				return result;
#line 973 "BluetoothIndicator.c"
			}
		}
	}
}

/**
 * Filters out any unpaired devices from our listbox.
 */
static gboolean
bluetooth_indicator_filter_paired_devices (BluetoothIndicator* self,
                                           GtkListBoxRow* row)
{
	BluetoothClient* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Device1* _tmp2_;
	Device1* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 263 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 264 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->client;
#line 264 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (bluetooth_client_airplane_mode_enabled (_tmp0_)) {
#line 264 "../src/panel/applets/status/BluetoothIndicator.vala"
		result = FALSE;
#line 264 "../src/panel/applets/status/BluetoothIndicator.vala"
		return result;
#line 1005 "BluetoothIndicator.c"
	}
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = bt_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_BT_DEVICE_ROW, BTDeviceRow));
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = device1_get_paired (_tmp3_);
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = _tmp4_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp5_) {
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp1_ = TRUE;
#line 1019 "BluetoothIndicator.c"
	} else {
		Device1* _tmp6_;
		Device1* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp6_ = bt_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_BT_DEVICE_ROW, BTDeviceRow));
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp7_ = _tmp6_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp8_ = device1_get_connected (_tmp7_);
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp9_ = _tmp8_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp1_ = _tmp9_;
#line 1035 "BluetoothIndicator.c"
	}
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	result = _tmp1_;
#line 266 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 1041 "BluetoothIndicator.c"
}

/**
 * Update the tray icon and Bluetooth switch state to reflect the current
 * state of airplane mode.
 */
static void
bluetooth_indicator_update_state_ui (BluetoothIndicator* self)
{
	gboolean enabled = FALSE;
	BluetoothClient* _tmp0_;
	GtkSwitch* _tmp7_;
	GtkSwitch* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBox* _tmp11_;
#line 273 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->client;
#line 274 "../src/panel/applets/status/BluetoothIndicator.vala"
	enabled = bluetooth_client_airplane_mode_enabled (_tmp0_);
#line 277 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (enabled) {
#line 1066 "BluetoothIndicator.c"
		GtkImage* _tmp1_;
		GtkLabel* _tmp2_;
		GtkLabel* _tmp3_;
#line 278 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp1_ = self->image;
#line 278 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_image_set_from_icon_name (_tmp1_, "bluetooth-disabled-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 279 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp2_ = self->priv->placeholder_label;
#line 279 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_tmp2_, _ ("Airplane mode is on."));
#line 280 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp3_ = self->priv->placeholder_sublabel;
#line 280 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_tmp3_, _ ("Bluetooth is disabled while airplane mode is on."));
#line 1082 "BluetoothIndicator.c"
	} else {
		GtkImage* _tmp4_;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
#line 282 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp4_ = self->image;
#line 282 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_image_set_from_icon_name (_tmp4_, "bluetooth-active-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 283 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp5_ = self->priv->placeholder_label;
#line 283 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_tmp5_, _ ("No paired Bluetooth devices found."));
#line 284 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp6_ = self->priv->placeholder_sublabel;
#line 284 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_tmp6_, _ ("Visit Bluetooth settings to pair a device."));
#line 1099 "BluetoothIndicator.c"
	}
#line 288 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = self->priv->bluetooth_switch;
#line 288 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_handler_block (_tmp7_, self->priv->switch_handler_id);
#line 289 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = self->priv->bluetooth_switch;
#line 289 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_switch_set_active (_tmp8_, !enabled);
#line 290 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp9_ = self->priv->bluetooth_switch;
#line 290 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_handler_unblock (_tmp9_, self->priv->switch_handler_id);
#line 292 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp10_ = self->priv->devices_box;
#line 292 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_filter (_tmp10_);
#line 293 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp11_ = self->priv->devices_box;
#line 293 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_invalidate_sort (_tmp11_);
#line 1121 "BluetoothIndicator.c"
}

BluetoothIndicator*
bluetooth_indicator_construct (GType object_type)
{
	BluetoothIndicator * self = NULL;
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = (BluetoothIndicator*) g_object_new (object_type, NULL);
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	return self;
#line 1132 "BluetoothIndicator.c"
}

BluetoothIndicator*
bluetooth_indicator_new (void)
{
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	return bluetooth_indicator_construct (TYPE_BLUETOOTH_INDICATOR);
#line 1140 "BluetoothIndicator.c"
}

static gboolean
_bluetooth_indicator_on_button_released_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self)
{
	gboolean result;
	result = bluetooth_indicator_on_button_released ((BluetoothIndicator*) self, event);
#line 39 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 1152 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda24_ (BluetoothIndicator* self,
                                  Device1* device)
{
#line 45 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (device != NULL);
#line 47 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_remove_device (self, device);
#line 49 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_add_device (self, device);
#line 1165 "BluetoothIndicator.c"
}

static void
__bluetooth_indicator___lambda24__bluetooth_client_device_added (BluetoothClient* _sender,
                                                                 Device1* device,
                                                                 gpointer self)
{
#line 45 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda24_ ((BluetoothIndicator*) self, device);
#line 1175 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda25_ (BluetoothIndicator* self,
                                  Device1* device)
{
#line 52 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (device != NULL);
#line 53 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_remove_device (self, device);
#line 1186 "BluetoothIndicator.c"
}

static void
__bluetooth_indicator___lambda25__bluetooth_client_device_removed (BluetoothClient* _sender,
                                                                   Device1* device,
                                                                   gpointer self)
{
#line 52 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda25_ ((BluetoothIndicator*) self, device);
#line 1196 "BluetoothIndicator.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	return _data9_;
#line 1206 "BluetoothIndicator.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 1216 "BluetoothIndicator.c"
		BluetoothIndicator* self;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
		self = _data9_->self;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (_data9_->up_device);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_slice_free (Block9Data, _data9_);
#line 1226 "BluetoothIndicator.c"
	}
}

static void
__lambda27_ (Block9Data* _data9_,
             GtkWidget* row)
{
	BluetoothIndicator* self;
	BTDeviceRow* device_row = NULL;
	BTDeviceRow* _tmp0_;
	BTDeviceRow* _tmp1_;
	Device1* _tmp2_;
	Device1* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_;
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = _data9_->self;
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (row != NULL);
#line 59 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (IS_BT_DEVICE_ROW (row) ? ((BTDeviceRow*) row) : NULL);
#line 59 "../src/panel/applets/status/BluetoothIndicator.vala"
	device_row = _tmp0_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = device_row;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = bt_device_row_get_device (_tmp1_);
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = device1_get_address (_tmp3_);
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = _tmp4_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = _tmp5_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_data9_->up_device, "serial", &_tmp7_, NULL);
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = _tmp7_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp9_ = _tmp8_;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp10_ = g_strcmp0 (_tmp6_, _tmp9_) == 0;
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp9_);
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp6_);
#line 60 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp10_) {
#line 1281 "BluetoothIndicator.c"
		BTDeviceRow* _tmp11_;
#line 61 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp11_ = device_row;
#line 61 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_set_up_device (_tmp11_, _data9_->up_device);
#line 1287 "BluetoothIndicator.c"
	}
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (device_row);
#line 1291 "BluetoothIndicator.c"
}

static void
___lambda27__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	__lambda27_ (self, widget);
#line 1300 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda26_ (BluetoothIndicator* self,
                                  UpDevice* up_device)
{
	Block9Data* _data9_;
	UpDevice* _tmp0_;
	GtkListBox* _tmp1_;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (up_device != NULL);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data9_->_ref_count_ = 1;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data9_->self = g_object_ref (self);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (up_device);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (_data9_->up_device);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data9_->up_device = _tmp0_;
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->devices_box;
#line 58 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda27__gtk_callback, _data9_);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	block9_data_unref (_data9_);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data9_ = NULL;
#line 1332 "BluetoothIndicator.c"
}

static void
__bluetooth_indicator___lambda26__bluetooth_client_upower_device_added (BluetoothClient* _sender,
                                                                        UpDevice* up_device,
                                                                        gpointer self)
{
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda26_ ((BluetoothIndicator*) self, up_device);
#line 1342 "BluetoothIndicator.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	return _data10_;
#line 1352 "BluetoothIndicator.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1362 "BluetoothIndicator.c"
		BluetoothIndicator* self;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
		self = _data10_->self;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_data10_->path);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_slice_free (Block10Data, _data10_);
#line 1372 "BluetoothIndicator.c"
	}
}

static void
__lambda29_ (Block10Data* _data10_,
             GtkWidget* row)
{
	BluetoothIndicator* self;
	BTDeviceRow* device_row = NULL;
	BTDeviceRow* _tmp0_;
	BTDeviceRow* _tmp1_;
	Device1* _tmp2_;
	Device1* _tmp3_;
	const gchar* _tmp4_;
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = _data10_->self;
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (row != NULL);
#line 69 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (IS_BT_DEVICE_ROW (row) ? ((BTDeviceRow*) row) : NULL);
#line 69 "../src/panel/applets/status/BluetoothIndicator.vala"
	device_row = _tmp0_;
#line 70 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = device_row;
#line 70 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = bt_device_row_get_device (_tmp1_);
#line 70 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 70 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = g_dbus_proxy_get_object_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_dbus_proxy_get_type (), GDBusProxy));
#line 70 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (g_strcmp0 (_tmp4_, _data10_->path) == 0) {
#line 1405 "BluetoothIndicator.c"
		BTDeviceRow* _tmp5_;
#line 71 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp5_ = device_row;
#line 71 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_set_up_device (_tmp5_, NULL);
#line 1411 "BluetoothIndicator.c"
	}
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (device_row);
#line 1415 "BluetoothIndicator.c"
}

static void
___lambda29__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	__lambda29_ (self, widget);
#line 1424 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda28_ (BluetoothIndicator* self,
                                  const gchar* path)
{
	Block10Data* _data10_;
	gchar* _tmp0_;
	GtkListBox* _tmp1_;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (path != NULL);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data10_->_ref_count_ = 1;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data10_->self = g_object_ref (self);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = g_strdup (path);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_data10_->path);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data10_->path = _tmp0_;
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->devices_box;
#line 68 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda29__gtk_callback, _data10_);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	block10_data_unref (_data10_);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data10_ = NULL;
#line 1456 "BluetoothIndicator.c"
}

static void
__bluetooth_indicator___lambda28__bluetooth_client_upower_device_removed (BluetoothClient* _sender,
                                                                          const gchar* object_path,
                                                                          gpointer self)
{
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda28_ ((BluetoothIndicator*) self, object_path);
#line 1466 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator_update_state_ui_bluetooth_client_airplane_mode_changed (BluetoothClient* _sender,
                                                                             gpointer self)
{
#line 77 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_update_state_ui ((BluetoothIndicator*) self);
#line 1475 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda30_ (BluetoothIndicator* self)
{
	BluetoothClient* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 81 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->client;
#line 81 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = bluetooth_client_get_has_adapter (_tmp0_);
#line 81 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp2_) {
#line 81 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 1494 "BluetoothIndicator.c"
	} else {
#line 82 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1498 "BluetoothIndicator.c"
	}
}

static void
__bluetooth_indicator___lambda30__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 80 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda30_ ((BluetoothIndicator*) self);
#line 1509 "BluetoothIndicator.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 1517 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator_on_settings_activate_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 116 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_settings_activate ((BluetoothIndicator*) self);
#line 1526 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator_on_switch_activate_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 122 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_switch_activate ((BluetoothIndicator*) self);
#line 1536 "BluetoothIndicator.c"
}

static gboolean
_bluetooth_indicator_filter_paired_devices_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                     gpointer self)
{
	gboolean result;
	result = bluetooth_indicator_filter_paired_devices ((BluetoothIndicator*) self, row);
#line 138 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 1547 "BluetoothIndicator.c"
}

static gint
_bluetooth_indicator_sort_devices_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                          GtkListBoxRow* row2,
                                                          gpointer self)
{
	gint result;
	result = bluetooth_indicator_sort_devices ((BluetoothIndicator*) self, row1, row2);
#line 139 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 1559 "BluetoothIndicator.c"
}

static void
_bluetooth_indicator___lambda31_ (BluetoothIndicator* self,
                                  GtkListBoxRow* row)
{
#line 142 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (row != NULL);
#line 143 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_toggle_connection (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_BT_DEVICE_ROW, BTDeviceRow), NULL, NULL);
#line 1570 "BluetoothIndicator.c"
}

static void
__bluetooth_indicator___lambda31__gtk_list_box_row_activated (GtkListBox* _sender,
                                                              GtkListBoxRow* row,
                                                              gpointer self)
{
#line 142 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bluetooth_indicator___lambda31_ ((BluetoothIndicator*) self, row);
#line 1580 "BluetoothIndicator.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1588 "BluetoothIndicator.c"
}

static GObject *
bluetooth_indicator_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothIndicator * self;
	GtkImage* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkImage* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkEventBox* _tmp5_;
	BluetoothClient* _tmp6_;
	ObexManager* _tmp7_;
	BluetoothClient* _tmp8_;
	BluetoothClient* _tmp9_;
	BluetoothClient* _tmp10_;
	BluetoothClient* _tmp11_;
	BluetoothClient* _tmp12_;
	BluetoothClient* _tmp13_;
	GtkEventBox* _tmp14_;
	BudgiePopover* _tmp15_;
	BudgiePopover* _tmp16_;
	BudgiePopover* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkBox* box = NULL;
	GtkBox* _tmp19_;
	GtkBox* header = NULL;
	GtkBox* _tmp20_ = NULL;
	GtkBox* _tmp21_;
	GtkStyleContext* _tmp22_;
	PangoAttrList* header_attributes = NULL;
	PangoAttrList* _tmp23_;
	PangoFontDescription* weight_attr = NULL;
	PangoFontDescription* _tmp24_;
	PangoFontDescription* _tmp25_;
	PangoAttrList* _tmp26_;
	PangoFontDescription* _tmp27_;
	PangoAttrFontDesc* _tmp28_;
	GtkLabel* switch_label = NULL;
	PangoAttrList* _tmp29_;
	PangoAttrList* _tmp30_;
	GtkLabel* _tmp31_ = NULL;
	GtkLabel* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkButton* settings_button = NULL;
	gchar* _tmp34_;
	GtkButton* _tmp35_ = NULL;
	GtkButton* _tmp36_;
	gchar* _tmp37_;
	GtkSwitch* _tmp38_ = NULL;
	GtkSwitch* _tmp39_;
	gulong _tmp40_;
	GtkBox* _tmp41_;
	GtkLabel* _tmp42_;
	GtkBox* _tmp43_;
	GtkSwitch* _tmp44_;
	GtkBox* _tmp45_;
	GtkButton* _tmp46_;
	GtkScrolledWindow* scrolled_window = NULL;
	GtkScrolledWindow* _tmp47_ = NULL;
	GtkListBox* _tmp48_ = NULL;
	GtkListBox* _tmp49_;
	GtkListBox* _tmp50_;
	GtkListBox* _tmp51_;
	GtkStyleContext* _tmp52_;
	GtkListBox* _tmp53_;
	GtkBox* placeholder = NULL;
	GtkBox* _tmp54_ = NULL;
	PangoAttrList* label_attributes = NULL;
	PangoAttrList* _tmp55_;
	PangoAttrList* _tmp56_;
	PangoFontDescription* _tmp57_;
	PangoAttrFontDesc* _tmp58_;
	PangoAttrList* _tmp59_;
	PangoAttrList* _tmp60_;
	GtkLabel* _tmp61_ = NULL;
	GtkLabel* _tmp62_;
	GtkStyleContext* _tmp63_;
	GtkLabel* _tmp64_;
	GtkStyleContext* _tmp65_;
	GtkLabel* _tmp66_ = NULL;
	GtkBox* _tmp67_;
	GtkLabel* _tmp68_;
	GtkBox* _tmp69_;
	GtkLabel* _tmp70_;
	GtkBox* _tmp71_;
	GtkListBox* _tmp72_;
	GtkBox* _tmp73_;
	GtkScrolledWindow* _tmp74_;
	GtkListBox* _tmp75_;
	GtkEventBox* _tmp76_;
	GtkBox* _tmp77_;
	GtkBox* _tmp78_;
	GtkBox* _tmp79_;
	GtkSeparator* _tmp80_;
	GtkSeparator* _tmp81_;
	GtkBox* _tmp82_;
	GtkScrolledWindow* _tmp83_;
	GtkBox* _tmp84_;
	BudgiePopover* _tmp85_;
	GtkBox* _tmp86_;
	BluetoothClient* _tmp87_;
	gboolean _tmp88_;
	gboolean _tmp89_;
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_indicator_parent_class);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLUETOOTH_INDICATOR, BluetoothIndicator);
#line 34 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 34 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp0_);
#line 34 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->image);
#line 34 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->image = _tmp0_;
#line 36 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = (GtkEventBox*) gtk_event_box_new ();
#line 36 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 36 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 36 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->ebox = _tmp1_;
#line 37 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->ebox;
#line 37 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->image;
#line 37 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
#line 38 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->ebox;
#line 38 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp4_, (gint) GDK_BUTTON_RELEASE_MASK);
#line 39 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = self->ebox;
#line 39 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "button-release-event", (GCallback) _bluetooth_indicator_on_button_released_gtk_widget_button_release_event, self, 0);
#line 42 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = bluetooth_client_new ();
#line 42 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->client);
#line 42 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->client = _tmp6_;
#line 43 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = obex_manager_new ();
#line 43 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->obex_manager);
#line 43 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->obex_manager = _tmp7_;
#line 45 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = self->priv->client;
#line 45 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp8_, "device-added", (GCallback) __bluetooth_indicator___lambda24__bluetooth_client_device_added, self, 0);
#line 52 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp9_ = self->priv->client;
#line 52 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp9_, "device-removed", (GCallback) __bluetooth_indicator___lambda25__bluetooth_client_device_removed, self, 0);
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp10_ = self->priv->client;
#line 57 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp10_, "upower-device-added", (GCallback) __bluetooth_indicator___lambda26__bluetooth_client_upower_device_added, self, 0);
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp11_ = self->priv->client;
#line 67 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp11_, "upower-device-removed", (GCallback) __bluetooth_indicator___lambda28__bluetooth_client_upower_device_removed, self, 0);
#line 77 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp12_ = self->priv->client;
#line 77 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp12_, "airplane-mode-changed", (GCallback) _bluetooth_indicator_update_state_ui_bluetooth_client_airplane_mode_changed, self, 0);
#line 80 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp13_ = self->priv->client;
#line 80 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::has-adapter", (GCallback) __bluetooth_indicator___lambda30__g_object_notify, self, 0);
#line 86 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp14_ = self->ebox;
#line 86 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp15_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp14_);
#line 86 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp15_);
#line 86 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->popover);
#line 86 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->popover = _tmp15_;
#line 87 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp16_ = self->popover;
#line 87 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp16_, 275, -1);
#line 88 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp17_ = self->popover;
#line 88 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 88 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp18_, "bluetooth-popover");
#line 89 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 89 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp19_);
#line 89 "../src/panel/applets/status/BluetoothIndicator.vala"
	box = _tmp19_;
#line 92 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 92 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp20_, 4);
#line 92 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp20_, 4);
#line 92 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp20_);
#line 92 "../src/panel/applets/status/BluetoothIndicator.vala"
	header = _tmp20_;
#line 96 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp21_ = header;
#line 96 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
#line 96 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp22_, "bluetooth-header");
#line 99 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp23_ = pango_attr_list_new ();
#line 99 "../src/panel/applets/status/BluetoothIndicator.vala"
	header_attributes = _tmp23_;
#line 100 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp24_ = pango_font_description_new ();
#line 100 "../src/panel/applets/status/BluetoothIndicator.vala"
	weight_attr = _tmp24_;
#line 101 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp25_ = weight_attr;
#line 101 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_font_description_set_weight (_tmp25_, PANGO_WEIGHT_BOLD);
#line 102 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp26_ = header_attributes;
#line 102 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp27_ = weight_attr;
#line 102 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp28_ = (PangoAttrFontDesc*) pango_attr_font_desc_new (_tmp27_);
#line 102 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_attr_list_insert (_tmp26_, (PangoAttribute*) _tmp28_);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp29_ = header_attributes;
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp30_ = _pango_attr_list_ref0 (_tmp29_);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp31_ = (GtkLabel*) gtk_label_new (_ ("Bluetooth"));
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_attributes (_tmp31_, _tmp30_);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (_tmp30_);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp31_, GTK_ALIGN_START);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp31_, 4);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp31_);
#line 104 "../src/panel/applets/status/BluetoothIndicator.vala"
	switch_label = _tmp31_;
#line 109 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp32_ = switch_label;
#line 109 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 109 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp33_, GTK_STYLE_CLASS_DIM_LABEL);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp34_ = g_strdup (_ ("Bluetooth Settings"));
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp35_ = (GtkButton*) gtk_button_new_from_icon_name ("preferences-system-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_button_set_relief (_tmp35_, GTK_RELIEF_NONE);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp35_, _tmp34_);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp34_);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp35_);
#line 112 "../src/panel/applets/status/BluetoothIndicator.vala"
	settings_button = _tmp35_;
#line 116 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp36_ = settings_button;
#line 116 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) _bluetooth_indicator_on_settings_activate_gtk_button_clicked, self, 0);
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp37_ = g_strdup (_ ("Turn Bluetooth on or off"));
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp38_ = (GtkSwitch*) gtk_switch_new ();
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp38_, _tmp37_);
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp37_);
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp38_);
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->bluetooth_switch);
#line 119 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->bluetooth_switch = _tmp38_;
#line 122 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp39_ = self->priv->bluetooth_switch;
#line 122 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp40_ = g_signal_connect_object ((GObject*) _tmp39_, "notify::active", (GCallback) _bluetooth_indicator_on_switch_activate_g_object_notify, self, 0);
#line 122 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->switch_handler_id = _tmp40_;
#line 124 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp41_ = header;
#line 124 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp42_ = switch_label;
#line 124 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp41_, (GtkWidget*) _tmp42_, TRUE, TRUE, (guint) 0);
#line 125 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp43_ = header;
#line 125 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp44_ = self->priv->bluetooth_switch;
#line 125 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_end (_tmp43_, (GtkWidget*) _tmp44_, FALSE, FALSE, (guint) 0);
#line 126 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp45_ = header;
#line 126 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp46_ = settings_button;
#line 126 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_end (_tmp45_, (GtkWidget*) _tmp46_, FALSE, FALSE, (guint) 0);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp47_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_set (_tmp47_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_scrolled_window_set_min_content_height (_tmp47_, 190);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_scrolled_window_set_max_content_height (_tmp47_, 190);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp47_, TRUE);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp47_);
#line 129 "../src/panel/applets/status/BluetoothIndicator.vala"
	scrolled_window = _tmp47_;
#line 135 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp48_ = (GtkListBox*) gtk_list_box_new ();
#line 135 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_set_selection_mode (_tmp48_, GTK_SELECTION_NONE);
#line 135 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp48_);
#line 135 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->devices_box);
#line 135 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->devices_box = _tmp48_;
#line 138 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp49_ = self->priv->devices_box;
#line 138 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_set_filter_func (_tmp49_, _bluetooth_indicator_filter_paired_devices_gtk_list_box_filter_func, g_object_ref (self), g_object_unref);
#line 139 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp50_ = self->priv->devices_box;
#line 139 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_set_sort_func (_tmp50_, _bluetooth_indicator_sort_devices_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 140 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp51_ = self->priv->devices_box;
#line 140 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp52_ = gtk_widget_get_style_context ((GtkWidget*) _tmp51_);
#line 140 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp52_, "bluetooth-device-listbox");
#line 142 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp53_ = self->priv->devices_box;
#line 142 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp53_, "row-activated", (GCallback) __bluetooth_indicator___lambda31__gtk_list_box_row_activated, self, 0);
#line 147 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp54_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 147 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp54_, 18);
#line 147 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp54_);
#line 147 "../src/panel/applets/status/BluetoothIndicator.vala"
	placeholder = _tmp54_;
#line 151 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp55_ = pango_attr_list_new ();
#line 151 "../src/panel/applets/status/BluetoothIndicator.vala"
	label_attributes = _tmp55_;
#line 152 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp56_ = label_attributes;
#line 152 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp57_ = weight_attr;
#line 152 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp58_ = (PangoAttrFontDesc*) pango_attr_font_desc_new (_tmp57_);
#line 152 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_attr_list_insert (_tmp56_, (PangoAttribute*) _tmp58_);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp59_ = label_attributes;
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp60_ = _pango_attr_list_ref0 (_tmp59_);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp61_ = (GtkLabel*) gtk_label_new (NULL);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_attributes (_tmp61_, _tmp60_);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (_tmp60_);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_justify (_tmp61_, GTK_JUSTIFY_CENTER);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp61_);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->placeholder_label);
#line 154 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->placeholder_label = _tmp61_;
#line 159 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp62_ = self->priv->placeholder_label;
#line 159 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp63_ = gtk_widget_get_style_context ((GtkWidget*) _tmp62_);
#line 159 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp63_, GTK_STYLE_CLASS_DIM_LABEL);
#line 160 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp64_ = self->priv->placeholder_label;
#line 160 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp65_ = gtk_widget_get_style_context ((GtkWidget*) _tmp64_);
#line 160 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp65_, "bluetooth-placeholder");
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp66_ = (GtkLabel*) gtk_label_new (NULL);
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_justify (_tmp66_, GTK_JUSTIFY_CENTER);
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_set (_tmp66_, "wrap", TRUE, NULL);
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp66_);
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->placeholder_sublabel);
#line 162 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->placeholder_sublabel = _tmp66_;
#line 167 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp67_ = placeholder;
#line 167 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp68_ = self->priv->placeholder_label;
#line 167 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp67_, (GtkWidget*) _tmp68_, FALSE, TRUE, (guint) 0);
#line 168 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp69_ = placeholder;
#line 168 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp70_ = self->priv->placeholder_sublabel;
#line 168 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp69_, (GtkWidget*) _tmp70_, FALSE, TRUE, (guint) 0);
#line 169 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp71_ = placeholder;
#line 169 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp71_);
#line 170 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp72_ = self->priv->devices_box;
#line 170 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp73_ = placeholder;
#line 170 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_list_box_set_placeholder (_tmp72_, (GtkWidget*) _tmp73_);
#line 171 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp74_ = scrolled_window;
#line 171 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp75_ = self->priv->devices_box;
#line 171 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
#line 174 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_update_state_ui (self);
#line 176 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp76_ = self->ebox;
#line 176 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp76_);
#line 177 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp77_ = box;
#line 177 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp78_ = header;
#line 177 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp77_, (GtkWidget*) _tmp78_, TRUE, TRUE, (guint) 0);
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp79_ = box;
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp80_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp80_);
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp81_ = _tmp80_;
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp79_, (GtkWidget*) _tmp81_, TRUE, TRUE, (guint) 4);
#line 178 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (_tmp81_);
#line 179 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp82_ = box;
#line 179 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp83_ = scrolled_window;
#line 179 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp82_, (GtkWidget*) _tmp83_, TRUE, TRUE, (guint) 0);
#line 180 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp84_ = box;
#line 180 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp84_);
#line 181 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp85_ = self->popover;
#line 181 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp86_ = box;
#line 181 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp85_, (GtkWidget*) _tmp86_);
#line 184 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp87_ = self->priv->client;
#line 184 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp88_ = bluetooth_client_get_has_adapter (_tmp87_);
#line 184 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp89_ = _tmp88_;
#line 184 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp89_) {
#line 184 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 2094 "BluetoothIndicator.c"
	}
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (label_attributes);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (placeholder);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (scrolled_window);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (settings_button);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (switch_label);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	__vala_PangoFontDescription_free0 (weight_attr);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (header_attributes);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (header);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (box);
#line 33 "../src/panel/applets/status/BluetoothIndicator.vala"
	return obj;
#line 2116 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_class_init (BluetoothIndicatorClass * klass,
                                gpointer klass_data)
{
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothIndicator_private_offset);
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_indicator_constructor;
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_indicator_finalize;
#line 2131 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_instance_init (BluetoothIndicator * self,
                                   gpointer klass)
{
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv = bluetooth_indicator_get_instance_private (self);
#line 19 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->image = NULL;
#line 20 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->ebox = NULL;
#line 21 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->popover = NULL;
#line 23 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->devices_box = NULL;
#line 24 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->bluetooth_switch = NULL;
#line 25 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->placeholder_label = NULL;
#line 26 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->placeholder_sublabel = NULL;
#line 2154 "BluetoothIndicator.c"
}

static void
bluetooth_indicator_finalize (GObject * obj)
{
	BluetoothIndicator * self;
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLUETOOTH_INDICATOR, BluetoothIndicator);
#line 19 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->image);
#line 20 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 21 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->popover);
#line 23 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->devices_box);
#line 24 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->bluetooth_switch);
#line 25 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->placeholder_label);
#line 26 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->placeholder_sublabel);
#line 28 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->client);
#line 29 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->obex_manager);
#line 18 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (bluetooth_indicator_parent_class)->finalize (obj);
#line 2183 "BluetoothIndicator.c"
}

GType
bluetooth_indicator_get_type (void)
{
	return bluetooth_indicator_type_id;
}

GType
bluetooth_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothIndicator), 0, (GInstanceInitFunc) bluetooth_indicator_instance_init, NULL };
	bluetooth_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "BluetoothIndicator", &g_define_type_info, 0);
	BluetoothIndicator_private_offset = sizeof (BluetoothIndicatorPrivate);
	return bluetooth_indicator_type_id;
}

static inline gpointer
bt_device_row_get_instance_private (BTDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BTDeviceRow_private_offset);
}

BTDeviceRow*
bt_device_row_construct (GType object_type,
                         Device1* device,
                         ObexManager* obex_manager)
{
	BTDeviceRow * self = NULL;
#line 534 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 534 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (obex_manager != NULL, NULL);
#line 535 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = (BTDeviceRow*) g_object_new (object_type, "device", device, "obex-manager", obex_manager, NULL);
#line 534 "../src/panel/applets/status/BluetoothIndicator.vala"
	return self;
#line 2221 "BluetoothIndicator.c"
}

BTDeviceRow*
bt_device_row_new (Device1* device,
                   ObexManager* obex_manager)
{
#line 534 "../src/panel/applets/status/BluetoothIndicator.vala"
	return bt_device_row_construct (TYPE_BT_DEVICE_ROW, device, obex_manager);
#line 2230 "BluetoothIndicator.c"
}

static void
bt_device_row_hide_progress_revealer (BTDeviceRow* self)
{
	GtkLabel* _tmp0_;
	GtkRevealer* _tmp1_;
#line 538 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 539 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->progress_label;
#line 539 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_label (_tmp0_, "");
#line 540 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->progress_revealer;
#line 540 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 2248 "BluetoothIndicator.c"
}

static void
bt_device_row_toggle_connection_data_free (gpointer _data)
{
	BtDeviceRowToggleConnectionData* _data_;
	_data_ = _data;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (_data_->self);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_slice_free (BtDeviceRowToggleConnectionData, _data_);
#line 2260 "BluetoothIndicator.c"
}

void
bt_device_row_toggle_connection (BTDeviceRow* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	BtDeviceRowToggleConnectionData* _data_;
	BTDeviceRow* _tmp0_;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_ = g_slice_new0 (BtDeviceRowToggleConnectionData);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bt_device_row_toggle_connection_data_free);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->self = _tmp0_;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_toggle_connection_co (_data_);
#line 2284 "BluetoothIndicator.c"
}

void
bt_device_row_toggle_connection_finish (BTDeviceRow* self,
                                        GAsyncResult* _res_)
{
	BtDeviceRowToggleConnectionData* _data_;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2294 "BluetoothIndicator.c"
}

/**
 * Attempts to either connect to or disconnect from the Bluetooth
 * device depending on its current connection state.
 */
static void
bt_device_row_toggle_connection_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	BtDeviceRowToggleConnectionData* _data_;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_ = _user_data_;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_source_object_ = source_object;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_res_ = _res_;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_toggle_connection_co (_data_);
#line 2315 "BluetoothIndicator.c"
}

static gboolean
bt_device_row_toggle_connection_co (BtDeviceRowToggleConnectionData* _data_)
{
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
	switch (_data_->_state_) {
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		case 0:
#line 2325 "BluetoothIndicator.c"
		goto _state_0;
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		case 1:
#line 2329 "BluetoothIndicator.c"
		goto _state_1;
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		case 2:
#line 2333 "BluetoothIndicator.c"
		goto _state_2;
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		case 3:
#line 2337 "BluetoothIndicator.c"
		goto _state_3;
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		case 4:
#line 2341 "BluetoothIndicator.c"
		goto _state_4;
		default:
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_assert_not_reached ();
#line 2346 "BluetoothIndicator.c"
	}
	_state_0:
#line 550 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp0_ = _data_->self->priv->progress_revealer;
#line 550 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp1_ = gtk_revealer_get_child_revealed (_data_->_tmp0_);
#line 550 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 550 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_data_->_tmp2_) {
#line 2357 "BluetoothIndicator.c"
		{
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_state_ = 1;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_bus_get (G_BUS_TYPE_SESSION, NULL, bt_device_row_toggle_connection_ready, _data_);
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			return FALSE;
#line 2365 "BluetoothIndicator.c"
			_state_1:
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp3_ = g_bus_get_finish (_data_->_res_, &_data_->_inner_error0_);
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->conn = _data_->_tmp3_;
#line 552 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2373 "BluetoothIndicator.c"
				goto __catch0_g_error;
			}
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp4_ = _data_->conn;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp5_ = _data_->self->transfer;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp6_ = transfer_get_session (_data_->_tmp5_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp9_ = g_variant_new ("(s)", _data_->_tmp8_, NULL);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_variant_ref_sink (_data_->_tmp9_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_state_ = 2;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_dbus_connection_call (_data_->_tmp4_, BT_DEVICE_ROW_OBEX_AGENT, BT_DEVICE_ROW_OBEX_PATH, BT_DEVICE_ROW_OBEX_AGENT, "TransferActive", _data_->_tmp10_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, bt_device_row_toggle_connection_ready, _data_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			return FALSE;
#line 2398 "BluetoothIndicator.c"
			_state_2:
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp11_ = g_dbus_connection_call_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_variant_unref0 (_data_->_tmp12_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_variant_unref0 (_data_->_tmp10_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_free0 (_data_->_tmp8_);
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 553 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_object_unref0 (_data_->conn);
#line 2414 "BluetoothIndicator.c"
				goto __catch0_g_error;
			}
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_object_unref0 (_data_->conn);
#line 2419 "BluetoothIndicator.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->e = _data_->_inner_error0_;
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_inner_error0_ = NULL;
#line 564 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp13_ = _data_->e;
#line 564 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp14_ = _data_->_tmp13_->message;
#line 564 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_warning ("BluetoothIndicator.vala:564: Error activating Bluetooth file transfer:" \
" %s", _data_->_tmp14_);
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_error_free0 (_data_->e);
#line 2436 "BluetoothIndicator.c"
		}
		__finally0:
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_object_unref (_data_->_async_result);
#line 551 "../src/panel/applets/status/BluetoothIndicator.vala"
			return FALSE;
#line 2449 "BluetoothIndicator.c"
		}
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_data_->_state_ != 0) {
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2459 "BluetoothIndicator.c"
			}
		}
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_unref (_data_->_async_result);
#line 567 "../src/panel/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 2466 "BluetoothIndicator.c"
	}
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp15_ = _data_->self->priv->spinner;
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_data_->_tmp15_, "active", &_data_->_tmp16_, NULL);
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_data_->_tmp17_) {
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_data_->_state_ != 0) {
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2484 "BluetoothIndicator.c"
			}
		}
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_unref (_data_->_async_result);
#line 570 "../src/panel/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 2491 "BluetoothIndicator.c"
	}
#line 572 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp18_ = _data_->self->priv->spinner;
#line 572 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_set (_data_->_tmp18_, "active", TRUE, NULL);
#line 573 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp19_ = _data_->self->priv->revealer;
#line 573 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_data_->_tmp19_, TRUE);
#line 2501 "BluetoothIndicator.c"
	{
#line 576 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp20_ = _data_->self->priv->_device;
#line 576 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp21_ = device1_get_connected (_data_->_tmp20_);
#line 576 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 576 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_data_->_tmp22_) {
#line 577 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp23_ = _data_->self->priv->status_label;
#line 577 "../src/panel/applets/status/BluetoothIndicator.vala"
			gtk_label_set_label (_data_->_tmp23_, _ ("Disconnecting…"));
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp24_ = _data_->self->priv->_device;
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_state_ = 3;
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			device1_disconnect (_data_->_tmp24_, bt_device_row_toggle_connection_ready, _data_);
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			return FALSE;
#line 2523 "BluetoothIndicator.c"
			_state_3:
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			device1_disconnect_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error0_);
#line 578 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2529 "BluetoothIndicator.c"
				goto __catch1_g_error;
			}
		} else {
#line 580 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp25_ = _data_->self->priv->status_label;
#line 580 "../src/panel/applets/status/BluetoothIndicator.vala"
			gtk_label_set_label (_data_->_tmp25_, _ ("Connecting…"));
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp26_ = _data_->self->priv->_device;
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_state_ = 4;
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			device1_connect (_data_->_tmp26_, bt_device_row_toggle_connection_ready, _data_);
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			return FALSE;
#line 2545 "BluetoothIndicator.c"
			_state_4:
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			device1_connect_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
#line 581 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2551 "BluetoothIndicator.c"
				goto __catch1_g_error;
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_inner_error0_ = NULL;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp27_ = _data_->self->priv->_device;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp28_ = device1_get_alias (_data_->_tmp27_);
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp31_ = _data_->_vala1_e;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp32_ = _data_->_tmp31_->message;
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_warning ("BluetoothIndicator.vala:584: Failed to connect or disconnect Bluetooth" \
" device %s: %s", _data_->_tmp30_, _data_->_tmp32_);
#line 584 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_data_->_tmp30_);
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp34_ = _data_->self->priv->_device;
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp35_ = device1_get_connected (_data_->_tmp34_);
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp36_ = _data_->_tmp35_;
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_data_->_tmp36_) {
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp33_ = _ ("Failed to disconnect");
#line 2589 "BluetoothIndicator.c"
		} else {
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
			_data_->_tmp33_ = _ ("Failed to connect");
#line 2593 "BluetoothIndicator.c"
		}
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		_data_->_tmp37_ = _data_->self->priv->status_label;
#line 585 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_data_->_tmp37_, _data_->_tmp33_);
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 2601 "BluetoothIndicator.c"
	}
	__finally1:
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_unref (_data_->_async_result);
#line 575 "../src/panel/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 2614 "BluetoothIndicator.c"
	}
#line 588 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp38_ = _data_->self->priv->revealer;
#line 588 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_data_->_tmp38_, TRUE);
#line 589 "../src/panel/applets/status/BluetoothIndicator.vala"
	_data_->_tmp39_ = _data_->self->priv->spinner;
#line 589 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_set (_data_->_tmp39_, "active", FALSE, NULL);
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_data_->_state_ != 0) {
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2632 "BluetoothIndicator.c"
		}
	}
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_unref (_data_->_async_result);
#line 547 "../src/panel/applets/status/BluetoothIndicator.vala"
	return FALSE;
#line 2639 "BluetoothIndicator.c"
}

static void
bt_device_row_transfer_active (BTDeviceRow* self,
                               const gchar* address)
{
	Device1* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 592 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (address != NULL);
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->_device;
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = device1_get_address (_tmp0_);
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = g_strcmp0 (address, _tmp3_) == 0;
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp3_);
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp4_) {
#line 593 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_update_transfer_progress (self);
#line 2671 "BluetoothIndicator.c"
	}
}

static void
bt_device_row_transfer_added (BTDeviceRow* self,
                              const gchar* address,
                              Transfer* transfer)
{
	Device1* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 596 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 596 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (address != NULL);
#line 596 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (transfer != NULL);
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->_device;
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = device1_get_address (_tmp0_);
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = g_strcmp0 (address, _tmp3_) == 0;
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp3_);
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp4_) {
#line 2705 "BluetoothIndicator.c"
		Transfer* _tmp5_;
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp5_ = _g_object_ref0 (transfer);
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self->transfer);
#line 597 "../src/panel/applets/status/BluetoothIndicator.vala"
		self->transfer = _tmp5_;
#line 2713 "BluetoothIndicator.c"
	}
}

static void
bt_device_row_transfer_removed (BTDeviceRow* self,
                                Transfer* transfer)
{
#line 600 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (transfer != NULL);
#line 601 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_hide_progress_revealer (self);
#line 2727 "BluetoothIndicator.c"
}

static void
bt_device_row_update_battery (BTDeviceRow* self)
{
	UpDevice* _tmp0_;
	UpDevice* _tmp1_;
	gchar* fallback_icon_name = NULL;
	gchar* icon_name = NULL;
	gint rounded = 0;
	UpDevice* _tmp3_;
	UpDevice* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	UpDevice* _tmp7_;
	UpDevice* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gchar* _tmp28_;
	UpDevice* _tmp29_;
	UpDevice* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp44_;
	GtkIconTheme* _tmp45_;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp46_;
	const gchar* _tmp47_;
	GtkIconInfo* _tmp48_;
	GtkIconInfo* _tmp49_;
	GtkLabel* _tmp54_;
	UpDevice* _tmp55_;
	UpDevice* _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	GtkRevealer* _tmp61_;
#line 604 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = bt_device_row_get_up_device (self);
#line 605 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = _tmp0_;
#line 605 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp1_ == NULL) {
#line 2775 "BluetoothIndicator.c"
		GtkRevealer* _tmp2_;
#line 606 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp2_ = self->priv->battery_revealer;
#line 606 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 607 "../src/panel/applets/status/BluetoothIndicator.vala"
		return;
#line 2783 "BluetoothIndicator.c"
	}
#line 610 "../src/panel/applets/status/BluetoothIndicator.vala"
	fallback_icon_name = NULL;
#line 611 "../src/panel/applets/status/BluetoothIndicator.vala"
	icon_name = NULL;
#line 614 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = bt_device_row_get_up_device (self);
#line 614 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = _tmp3_;
#line 614 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_tmp4_, "percentage", &_tmp5_, NULL);
#line 614 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = _tmp5_;
#line 614 "../src/panel/applets/status/BluetoothIndicator.vala"
	rounded = ((gint) round (_tmp6_ / 10)) * 10;
#line 617 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = bt_device_row_get_up_device (self);
#line 617 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = _tmp7_;
#line 617 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_tmp8_, "percentage", &_tmp9_, NULL);
#line 617 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp10_ = _tmp9_;
#line 617 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp10_ <= ((gdouble) 10)) {
#line 2809 "BluetoothIndicator.c"
		gchar* _tmp11_;
#line 618 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp11_ = g_strdup ("battery-empty");
#line 618 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (fallback_icon_name);
#line 618 "../src/panel/applets/status/BluetoothIndicator.vala"
		fallback_icon_name = _tmp11_;
#line 2817 "BluetoothIndicator.c"
	} else {
		UpDevice* _tmp12_;
		UpDevice* _tmp13_;
		gdouble _tmp14_;
		gdouble _tmp15_;
#line 619 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp12_ = bt_device_row_get_up_device (self);
#line 619 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp13_ = _tmp12_;
#line 619 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_get (_tmp13_, "percentage", &_tmp14_, NULL);
#line 619 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp15_ = _tmp14_;
#line 619 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_tmp15_ <= ((gdouble) 25)) {
#line 2833 "BluetoothIndicator.c"
			gchar* _tmp16_;
#line 620 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp16_ = g_strdup ("battery-caution");
#line 620 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_free0 (fallback_icon_name);
#line 620 "../src/panel/applets/status/BluetoothIndicator.vala"
			fallback_icon_name = _tmp16_;
#line 2841 "BluetoothIndicator.c"
		} else {
			UpDevice* _tmp17_;
			UpDevice* _tmp18_;
			gdouble _tmp19_;
			gdouble _tmp20_;
#line 621 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp17_ = bt_device_row_get_up_device (self);
#line 621 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp18_ = _tmp17_;
#line 621 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_object_get (_tmp18_, "percentage", &_tmp19_, NULL);
#line 621 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp20_ = _tmp19_;
#line 621 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (_tmp20_ <= ((gdouble) 50)) {
#line 2857 "BluetoothIndicator.c"
				gchar* _tmp21_;
#line 622 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp21_ = g_strdup ("battery-low");
#line 622 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_free0 (fallback_icon_name);
#line 622 "../src/panel/applets/status/BluetoothIndicator.vala"
				fallback_icon_name = _tmp21_;
#line 2865 "BluetoothIndicator.c"
			} else {
				UpDevice* _tmp22_;
				UpDevice* _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
#line 623 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp22_ = bt_device_row_get_up_device (self);
#line 623 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp23_ = _tmp22_;
#line 623 "../src/panel/applets/status/BluetoothIndicator.vala"
				g_object_get (_tmp23_, "percentage", &_tmp24_, NULL);
#line 623 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp25_ = _tmp24_;
#line 623 "../src/panel/applets/status/BluetoothIndicator.vala"
				if (_tmp25_ <= ((gdouble) 75)) {
#line 2881 "BluetoothIndicator.c"
					gchar* _tmp26_;
#line 624 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp26_ = g_strdup ("battery-good");
#line 624 "../src/panel/applets/status/BluetoothIndicator.vala"
					_g_free0 (fallback_icon_name);
#line 624 "../src/panel/applets/status/BluetoothIndicator.vala"
					fallback_icon_name = _tmp26_;
#line 2889 "BluetoothIndicator.c"
				} else {
					gchar* _tmp27_;
#line 626 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp27_ = g_strdup ("battery-full");
#line 626 "../src/panel/applets/status/BluetoothIndicator.vala"
					_g_free0 (fallback_icon_name);
#line 626 "../src/panel/applets/status/BluetoothIndicator.vala"
					fallback_icon_name = _tmp27_;
#line 2898 "BluetoothIndicator.c"
				}
			}
		}
	}
#line 629 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp28_ = g_strdup_printf ("battery-level-%d", rounded);
#line 629 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (icon_name);
#line 629 "../src/panel/applets/status/BluetoothIndicator.vala"
	icon_name = _tmp28_;
#line 632 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp29_ = bt_device_row_get_up_device (self);
#line 632 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp30_ = _tmp29_;
#line 632 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_tmp30_, "state", &_tmp31_, NULL);
#line 632 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp32_ = _tmp31_;
#line 632 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp32_ == ((guint) 4)) {
#line 2919 "BluetoothIndicator.c"
		gchar* _tmp33_;
#line 633 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp33_ = g_strdup ("battery-full-charged");
#line 633 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (icon_name);
#line 633 "../src/panel/applets/status/BluetoothIndicator.vala"
		icon_name = _tmp33_;
#line 2927 "BluetoothIndicator.c"
	} else {
		UpDevice* _tmp34_;
		UpDevice* _tmp35_;
		guint _tmp36_;
		guint _tmp37_;
#line 634 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp34_ = bt_device_row_get_up_device (self);
#line 634 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp35_ = _tmp34_;
#line 634 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_get (_tmp35_, "state", &_tmp36_, NULL);
#line 634 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp37_ = _tmp36_;
#line 634 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_tmp37_ == ((guint) 1)) {
#line 2943 "BluetoothIndicator.c"
			const gchar* _tmp38_;
			gchar* _tmp39_;
			const gchar* _tmp40_;
			gchar* _tmp41_;
#line 635 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp38_ = icon_name;
#line 635 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp39_ = g_strconcat (_tmp38_, "-charging-symbolic", NULL);
#line 635 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_free0 (icon_name);
#line 635 "../src/panel/applets/status/BluetoothIndicator.vala"
			icon_name = _tmp39_;
#line 636 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp40_ = fallback_icon_name;
#line 636 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp41_ = g_strconcat (_tmp40_, "-charging-symbolic", NULL);
#line 636 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_free0 (fallback_icon_name);
#line 636 "../src/panel/applets/status/BluetoothIndicator.vala"
			fallback_icon_name = _tmp41_;
#line 2964 "BluetoothIndicator.c"
		} else {
			const gchar* _tmp42_;
			gchar* _tmp43_;
#line 638 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp42_ = icon_name;
#line 638 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp43_ = g_strconcat (_tmp42_, "-symbolic", NULL);
#line 638 "../src/panel/applets/status/BluetoothIndicator.vala"
			_g_free0 (icon_name);
#line 638 "../src/panel/applets/status/BluetoothIndicator.vala"
			icon_name = _tmp43_;
#line 2976 "BluetoothIndicator.c"
		}
	}
#line 641 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp44_ = gtk_icon_theme_get_default ();
#line 641 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp45_ = _g_object_ref0 (_tmp44_);
#line 641 "../src/panel/applets/status/BluetoothIndicator.vala"
	theme = _tmp45_;
#line 642 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp46_ = theme;
#line 642 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp47_ = icon_name;
#line 642 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp48_ = gtk_icon_theme_lookup_icon (_tmp46_, _tmp47_, (gint) GTK_ICON_SIZE_MENU, 0);
#line 642 "../src/panel/applets/status/BluetoothIndicator.vala"
	icon_info = _tmp48_;
#line 644 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp49_ = icon_info;
#line 644 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp49_ == NULL) {
#line 2997 "BluetoothIndicator.c"
		GtkImage* _tmp50_;
		const gchar* _tmp51_;
#line 645 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp50_ = self->priv->battery_icon;
#line 645 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp51_ = fallback_icon_name;
#line 645 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_image_set_from_icon_name (_tmp50_, _tmp51_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 3006 "BluetoothIndicator.c"
	} else {
		GtkImage* _tmp52_;
		const gchar* _tmp53_;
#line 647 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp52_ = self->priv->battery_icon;
#line 647 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp53_ = icon_name;
#line 647 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_image_set_from_icon_name (_tmp52_, _tmp53_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 3016 "BluetoothIndicator.c"
	}
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp54_ = self->priv->battery_label;
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp55_ = bt_device_row_get_up_device (self);
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp56_ = _tmp55_;
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_get (_tmp56_, "percentage", &_tmp57_, NULL);
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp58_ = _tmp57_;
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp59_ = g_strdup_printf ("%d%%", (gint) _tmp58_);
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp60_ = _tmp59_;
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_label (_tmp54_, _tmp60_);
#line 650 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp60_);
#line 652 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp61_ = self->priv->battery_revealer;
#line 652 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_tmp61_, TRUE);
#line 604 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (icon_info);
#line 604 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (theme);
#line 604 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (icon_name);
#line 604 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (fallback_icon_name);
#line 3048 "BluetoothIndicator.c"
}

static void
bt_device_row_update_status (BTDeviceRow* self)
{
	const gchar* _tmp0_ = NULL;
	Device1* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkLabel* _tmp4_;
	Device1* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	Device1* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GtkLabel* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gboolean _tmp31_;
#line 655 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->_device;
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = device1_get_connected (_tmp1_);
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp3_) {
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp0_ = _ ("Connected");
#line 3082 "BluetoothIndicator.c"
	} else {
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp0_ = _ ("Disconnected");
#line 3086 "BluetoothIndicator.c"
	}
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->priv->status_label;
#line 656 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_text (_tmp4_, _tmp0_);
#line 658 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = self->priv->_device;
#line 658 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = device1_get_connected (_tmp5_);
#line 658 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = _tmp6_;
#line 658 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp7_) {
#line 3100 "BluetoothIndicator.c"
		GtkButton* _tmp8_;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		Device1* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
#line 659 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp8_ = self->priv->connection_button;
#line 659 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_show ((GtkWidget*) _tmp8_);
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp11_ = self->priv->_device;
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp12_ = device1_get_class (_tmp11_);
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp13_ = _tmp12_;
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		if ((_tmp13_ & BT_DEVICE_ROW_SMARTPHONE_MASK) == BT_DEVICE_ROW_SMARTPHONE_MASK) {
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp10_ = TRUE;
#line 3121 "BluetoothIndicator.c"
		} else {
			Device1* _tmp14_;
			guint32 _tmp15_;
			guint32 _tmp16_;
#line 664 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp14_ = self->priv->_device;
#line 664 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp15_ = device1_get_class (_tmp14_);
#line 664 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp16_ = _tmp15_;
#line 664 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp10_ = (_tmp16_ & BT_DEVICE_ROW_DESKTOP_MASK) == BT_DEVICE_ROW_DESKTOP_MASK;
#line 3134 "BluetoothIndicator.c"
		}
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_tmp10_) {
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp9_ = TRUE;
#line 3140 "BluetoothIndicator.c"
		} else {
			Device1* _tmp17_;
			guint32 _tmp18_;
			guint32 _tmp19_;
#line 665 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp17_ = self->priv->_device;
#line 665 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp18_ = device1_get_class (_tmp17_);
#line 665 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp19_ = _tmp18_;
#line 665 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp9_ = (_tmp19_ & BT_DEVICE_ROW_LAPTOP_MASK) == BT_DEVICE_ROW_LAPTOP_MASK;
#line 3153 "BluetoothIndicator.c"
		}
#line 663 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (_tmp9_) {
#line 3157 "BluetoothIndicator.c"
			GtkButton* _tmp20_;
#line 666 "../src/panel/applets/status/BluetoothIndicator.vala"
			_tmp20_ = self->priv->send_button;
#line 666 "../src/panel/applets/status/BluetoothIndicator.vala"
			gtk_widget_show ((GtkWidget*) _tmp20_);
#line 3163 "BluetoothIndicator.c"
		}
#line 669 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_update_battery (self);
#line 3167 "BluetoothIndicator.c"
	} else {
		GtkButton* _tmp21_;
		GtkButton* _tmp22_;
		GtkRevealer* _tmp23_;
#line 671 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp21_ = self->priv->connection_button;
#line 671 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp21_);
#line 672 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp22_ = self->priv->send_button;
#line 672 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp22_);
#line 673 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp23_ = self->priv->battery_revealer;
#line 673 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_revealer_set_reveal_child (_tmp23_, FALSE);
#line 3184 "BluetoothIndicator.c"
	}
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp24_ = self->priv->_device;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp25_ = device1_get_alias (_tmp24_);
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp26_ = _tmp25_;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp27_ = _tmp26_;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp28_ = self->priv->name_label;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp29_ = gtk_label_get_label (_tmp28_);
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp30_ = _tmp29_;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp31_ = g_strcmp0 (_tmp27_, _tmp30_) != 0;
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp27_);
#line 677 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp31_) {
#line 3206 "BluetoothIndicator.c"
		GtkLabel* _tmp32_;
		Device1* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		GtkLabel* _tmp37_;
		Device1* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp32_ = self->priv->name_label;
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp33_ = self->priv->_device;
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp34_ = device1_get_alias (_tmp33_);
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp35_ = _tmp34_;
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp36_ = _tmp35_;
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_label_set_label (_tmp32_, _tmp36_);
#line 678 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_tmp36_);
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp37_ = self->priv->name_label;
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp38_ = self->priv->_device;
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp39_ = device1_get_alias (_tmp38_);
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp40_ = _tmp39_;
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp41_ = _tmp40_;
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp37_, _tmp41_);
#line 679 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_tmp41_);
#line 3245 "BluetoothIndicator.c"
	}
#line 682 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_emit (self, bt_device_row_signals[BT_DEVICE_ROW_PROPERTIES_UPDATED_SIGNAL], 0);
#line 3249 "BluetoothIndicator.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 3268 "BluetoothIndicator.c"
}

static void
bt_device_row_update_transfer_progress (BTDeviceRow* self)
{
	Transfer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	static GQuark _tmp4_label0 = 0;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	static GQuark _tmp4_label1 = 0;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	static GQuark _tmp4_label2 = 0;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	static GQuark _tmp4_label3 = 0;
#line 685 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->transfer;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = transfer_get_status (_tmp0_);
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp1_;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = _tmp2_;
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_free (_tmp3_);
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("error")))) {
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
		switch (0) {
#line 3305 "BluetoothIndicator.c"
			default:
			{
#line 688 "../src/panel/applets/status/BluetoothIndicator.vala"
				bt_device_row_hide_progress_revealer (self);
#line 689 "../src/panel/applets/status/BluetoothIndicator.vala"
				break;
#line 3312 "BluetoothIndicator.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("queued")))) {
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
		switch (0) {
#line 3318 "BluetoothIndicator.c"
			default:
			{
#line 691 "../src/panel/applets/status/BluetoothIndicator.vala"
				bt_device_row_hide_progress_revealer (self);
#line 692 "../src/panel/applets/status/BluetoothIndicator.vala"
				break;
#line 3325 "BluetoothIndicator.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("active")))) {
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
		switch (0) {
#line 3331 "BluetoothIndicator.c"
			default:
			{
				GtkProgressBar* _tmp6_;
				Transfer* _tmp7_;
				guint64 _tmp8_;
				guint64 _tmp9_;
				Transfer* _tmp10_;
				guint64 _tmp11_;
				guint64 _tmp12_;
				GtkRevealer* _tmp13_;
				gchar* name = NULL;
				Transfer* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* file_name = NULL;
				Transfer* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp6_ = self->priv->progress_bar;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp7_ = self->transfer;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp8_ = transfer_get_transferred (_tmp7_);
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp9_ = _tmp8_;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp10_ = self->transfer;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp11_ = transfer_get_size (_tmp10_);
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp12_ = _tmp11_;
#line 695 "../src/panel/applets/status/BluetoothIndicator.vala"
				gtk_progress_bar_set_fraction (_tmp6_, ((gdouble) _tmp9_) / ((gdouble) _tmp12_));
#line 696 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp13_ = self->priv->progress_revealer;
#line 696 "../src/panel/applets/status/BluetoothIndicator.vala"
				gtk_revealer_set_reveal_child (_tmp13_, TRUE);
#line 697 "../src/panel/applets/status/BluetoothIndicator.vala"
				gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, TRUE);
#line 700 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp14_ = self->transfer;
#line 700 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp15_ = transfer_get_name (_tmp14_);
#line 700 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp16_ = _tmp15_;
#line 700 "../src/panel/applets/status/BluetoothIndicator.vala"
				name = _tmp16_;
#line 701 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp17_ = name;
#line 701 "../src/panel/applets/status/BluetoothIndicator.vala"
				if (_tmp17_ != NULL) {
#line 3386 "BluetoothIndicator.c"
					GtkLabel* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp18_ = self->priv->file_label;
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp19_ = name;
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp20_ = g_markup_escape_text (_tmp19_, (gssize) -1);
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp21_ = _tmp20_;
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp22_ = g_strdup_printf (_ ("<b>Filename</b>: %s"), _tmp21_);
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp23_ = _tmp22_;
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					gtk_label_set_markup (_tmp18_, _tmp23_);
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_g_free0 (_tmp23_);
#line 702 "../src/panel/applets/status/BluetoothIndicator.vala"
					_g_free0 (_tmp21_);
#line 3411 "BluetoothIndicator.c"
				}
#line 706 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp24_ = self->transfer;
#line 706 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp25_ = transfer_get_filename (_tmp24_);
#line 706 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp26_ = _tmp25_;
#line 706 "../src/panel/applets/status/BluetoothIndicator.vala"
				file_name = _tmp26_;
#line 707 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp27_ = file_name;
#line 707 "../src/panel/applets/status/BluetoothIndicator.vala"
				if (_tmp27_ != NULL) {
#line 3425 "BluetoothIndicator.c"
					const gchar* _tmp28_;
#line 708 "../src/panel/applets/status/BluetoothIndicator.vala"
					_tmp28_ = file_name;
#line 708 "../src/panel/applets/status/BluetoothIndicator.vala"
					if (string_contains (_tmp28_, "/.cache/obexd")) {
#line 3431 "BluetoothIndicator.c"
						GtkLabel* _tmp29_;
						Transfer* _tmp30_;
						guint64 _tmp31_;
						guint64 _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						Transfer* _tmp35_;
						guint64 _tmp36_;
						guint64 _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp29_ = self->priv->progress_label;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp30_ = self->transfer;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp31_ = transfer_get_transferred (_tmp30_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp32_ = _tmp31_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp33_ = g_format_size_full (_tmp32_, G_FORMAT_SIZE_DEFAULT);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp34_ = _tmp33_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp35_ = self->transfer;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp36_ = transfer_get_size (_tmp35_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp37_ = _tmp36_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp38_ = g_format_size_full (_tmp37_, G_FORMAT_SIZE_DEFAULT);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp39_ = _tmp38_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp40_ = g_strdup_printf (_ ("Receiving… %s of %s"), _tmp34_, _tmp39_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp41_ = _tmp40_;
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						gtk_label_set_label (_tmp29_, _tmp41_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp41_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp39_);
#line 709 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp34_);
#line 3479 "BluetoothIndicator.c"
					} else {
						GtkLabel* _tmp42_;
						Transfer* _tmp43_;
						guint64 _tmp44_;
						guint64 _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						Transfer* _tmp48_;
						guint64 _tmp49_;
						guint64 _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp42_ = self->priv->progress_label;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp43_ = self->transfer;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp44_ = transfer_get_transferred (_tmp43_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp45_ = _tmp44_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp46_ = g_format_size_full (_tmp45_, G_FORMAT_SIZE_DEFAULT);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp47_ = _tmp46_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp48_ = self->transfer;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp49_ = transfer_get_size (_tmp48_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp50_ = _tmp49_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp51_ = g_format_size_full (_tmp50_, G_FORMAT_SIZE_DEFAULT);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp52_ = _tmp51_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp53_ = g_strdup_printf (_ ("Sending… %s of %s"), _tmp47_, _tmp52_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_tmp54_ = _tmp53_;
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						gtk_label_set_label (_tmp42_, _tmp54_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp54_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp52_);
#line 714 "../src/panel/applets/status/BluetoothIndicator.vala"
						_g_free0 (_tmp47_);
#line 3528 "BluetoothIndicator.c"
					}
				}
#line 720 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_free0 (file_name);
#line 720 "../src/panel/applets/status/BluetoothIndicator.vala"
				_g_free0 (name);
#line 720 "../src/panel/applets/status/BluetoothIndicator.vala"
				break;
#line 3537 "BluetoothIndicator.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("complete")))) {
#line 686 "../src/panel/applets/status/BluetoothIndicator.vala"
		switch (0) {
#line 3543 "BluetoothIndicator.c"
			default:
			{
				Device1* _tmp55_;
				gboolean _tmp56_;
				gboolean _tmp57_;
#line 722 "../src/panel/applets/status/BluetoothIndicator.vala"
				bt_device_row_hide_progress_revealer (self);
#line 723 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp55_ = self->priv->_device;
#line 723 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp56_ = device1_get_connected (_tmp55_);
#line 723 "../src/panel/applets/status/BluetoothIndicator.vala"
				_tmp57_ = _tmp56_;
#line 723 "../src/panel/applets/status/BluetoothIndicator.vala"
				if (_tmp57_) {
#line 724 "../src/panel/applets/status/BluetoothIndicator.vala"
					gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, FALSE);
#line 3561 "BluetoothIndicator.c"
				}
#line 726 "../src/panel/applets/status/BluetoothIndicator.vala"
				break;
#line 3565 "BluetoothIndicator.c"
			}
		}
	}
}

Device1*
bt_device_row_get_device (BTDeviceRow* self)
{
	Device1* result;
	Device1* _tmp0_;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->_device;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	result = _tmp0_;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 3584 "BluetoothIndicator.c"
}

static void
bt_device_row_set_device (BTDeviceRow* self,
                          Device1* value)
{
	Device1* old_value;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	old_value = bt_device_row_get_device (self);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (old_value != value) {
#line 3598 "BluetoothIndicator.c"
		Device1* _tmp0_;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self->priv->_device);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
		self->priv->_device = _tmp0_;
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, bt_device_row_properties[BT_DEVICE_ROW_DEVICE_PROPERTY]);
#line 3608 "BluetoothIndicator.c"
	}
}

ObexManager*
bt_device_row_get_obex_manager (BTDeviceRow* self)
{
	ObexManager* result;
	ObexManager* _tmp0_;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->_obex_manager;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	result = _tmp0_;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 3625 "BluetoothIndicator.c"
}

static void
bt_device_row_set_obex_manager (BTDeviceRow* self,
                                ObexManager* value)
{
	ObexManager* old_value;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	old_value = bt_device_row_get_obex_manager (self);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (old_value != value) {
#line 3639 "BluetoothIndicator.c"
		ObexManager* _tmp0_;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (self->priv->_obex_manager);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
		self->priv->_obex_manager = _tmp0_;
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, bt_device_row_properties[BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY]);
#line 3649 "BluetoothIndicator.c"
	}
}

UpDevice*
bt_device_row_get_up_device (BTDeviceRow* self)
{
	UpDevice* result;
	UpDevice* _tmp0_;
#line 329 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 329 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->_up_device;
#line 329 "../src/panel/applets/status/BluetoothIndicator.vala"
	result = _tmp0_;
#line 329 "../src/panel/applets/status/BluetoothIndicator.vala"
	return result;
#line 3666 "BluetoothIndicator.c"
}

static void
_bt_device_row_up_device___lambda19_ (BTDeviceRow* self)
{
#line 342 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_update_battery (self);
#line 3674 "BluetoothIndicator.c"
}

static void
__bt_device_row_up_device___lambda19__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 341 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bt_device_row_up_device___lambda19_ ((BTDeviceRow*) self);
#line 3684 "BluetoothIndicator.c"
}

void
bt_device_row_set_up_device (BTDeviceRow* self,
                             UpDevice* value)
{
	UpDevice* _tmp1_;
	UpDevice* _tmp2_;
	UpDevice* _tmp3_;
	gulong _tmp4_;
#line 330 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (self->priv->up_handler_id != ((gulong) 0)) {
#line 3699 "BluetoothIndicator.c"
		UpDevice* _tmp0_;
#line 333 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp0_ = self->priv->_up_device;
#line 333 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->up_handler_id);
#line 334 "../src/panel/applets/status/BluetoothIndicator.vala"
		self->priv->up_handler_id = (gulong) 0;
#line 3707 "BluetoothIndicator.c"
	}
#line 337 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = _g_object_ref0 (value);
#line 337 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->_up_device);
#line 337 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->_up_device = _tmp1_;
#line 338 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_update_battery (self);
#line 340 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->priv->_up_device;
#line 340 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp2_ == NULL) {
#line 340 "../src/panel/applets/status/BluetoothIndicator.vala"
		return;
#line 3723 "BluetoothIndicator.c"
	}
#line 341 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->priv->_up_device;
#line 341 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = g_signal_connect_object ((GObject*) _tmp3_, "notify", (GCallback) __bt_device_row_up_device___lambda19__g_object_notify, self, 0);
#line 341 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->up_handler_id = _tmp4_;
#line 330 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_notify_by_pspec ((GObject *) self, bt_device_row_properties[BT_DEVICE_ROW_UP_DEVICE_PROPERTY]);
#line 3733 "BluetoothIndicator.c"
}

static void
_bt_device_row_transfer_active_obex_manager_transfer_active (ObexManager* _sender,
                                                             const gchar* address,
                                                             gpointer self)
{
#line 353 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_transfer_active ((BTDeviceRow*) self, address);
#line 3743 "BluetoothIndicator.c"
}

static void
_bt_device_row_transfer_added_obex_manager_transfer_added (ObexManager* _sender,
                                                           const gchar* address,
                                                           Transfer* transfer,
                                                           gpointer self)
{
#line 354 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_transfer_added ((BTDeviceRow*) self, address, transfer);
#line 3754 "BluetoothIndicator.c"
}

static void
_bt_device_row_transfer_removed_obex_manager_transfer_removed (ObexManager* _sender,
                                                               Transfer* transfer,
                                                               gpointer self)
{
#line 355 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_transfer_removed ((BTDeviceRow*) self, transfer);
#line 3764 "BluetoothIndicator.c"
}

static void
_bt_device_row___lambda20_ (BTDeviceRow* self)
{
	gchar** args = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	Device1* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gint args_length1;
	gint _args_size_;
	gchar** env = NULL;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint env_length1;
	gint _env_size_;
	GPid pid = 0;
	GError* _inner_error0_ = NULL;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = g_strdup ("org.buddiesofbudgie.sendto");
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = g_strdup ("-a");
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->priv->_device;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = device1_get_address (_tmp2_);
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = _tmp3_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = g_strdup ("-f");
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = g_new0 (gchar*, 4 + 1);
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_[0] = _tmp0_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_[1] = _tmp1_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_[2] = _tmp4_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_[3] = _tmp5_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	args = _tmp6_;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	args_length1 = 4;
#line 444 "../src/panel/applets/status/BluetoothIndicator.vala"
	_args_size_ = args_length1;
#line 445 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = _tmp7_ = g_get_environ ();
#line 445 "../src/panel/applets/status/BluetoothIndicator.vala"
	env = _tmp8_;
#line 445 "../src/panel/applets/status/BluetoothIndicator.vala"
	env_length1 = _vala_array_length (_tmp7_);
#line 445 "../src/panel/applets/status/BluetoothIndicator.vala"
	_env_size_ = env_length1;
#line 3823 "BluetoothIndicator.c"
	{
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar** _tmp10_;
		gint _tmp10__length1;
		GPid _tmp11_ = 0;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp9_ = args;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp9__length1 = args_length1;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp10_ = env;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp10__length1 = env_length1;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_spawn_async (NULL, _tmp9_, _tmp10_, G_SPAWN_SEARCH_PATH_FROM_ENVP, NULL, NULL, &_tmp11_, &_inner_error0_);
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		pid = _tmp11_;
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 3846 "BluetoothIndicator.c"
				goto __catch0_g_spawn_error;
			}
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			g_clear_error (&_inner_error0_);
#line 449 "../src/panel/applets/status/BluetoothIndicator.vala"
			return;
#line 3859 "BluetoothIndicator.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		e = _inner_error0_;
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		_inner_error0_ = NULL;
#line 458 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp12_ = e;
#line 458 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp13_ = _tmp12_->message;
#line 458 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_warning ("BluetoothIndicator.vala:458: Error starting sendto: %s", _tmp13_);
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (e);
#line 3880 "BluetoothIndicator.c"
	}
	__finally0:
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 448 "../src/panel/applets/status/BluetoothIndicator.vala"
		return;
#line 3895 "BluetoothIndicator.c"
	}
#line 443 "../src/panel/applets/status/BluetoothIndicator.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 443 "../src/panel/applets/status/BluetoothIndicator.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 3901 "BluetoothIndicator.c"
}

static void
__bt_device_row___lambda20__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 443 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bt_device_row___lambda20_ ((BTDeviceRow*) self);
#line 3910 "BluetoothIndicator.c"
}

static void
_bt_device_row___lambda21_ (BTDeviceRow* self)
{
#line 470 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_toggle_connection (self, NULL, NULL);
#line 3918 "BluetoothIndicator.c"
}

static void
__bt_device_row___lambda21__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 469 "../src/panel/applets/status/BluetoothIndicator.vala"
	_bt_device_row___lambda21_ ((BTDeviceRow*) self);
#line 3927 "BluetoothIndicator.c"
}

static void
_bt_device_row_update_status_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                GVariant* changed_properties,
                                                                gchar** invalidated_properties,
                                                                gpointer self)
{
#line 513 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_update_status ((BTDeviceRow*) self);
#line 3938 "BluetoothIndicator.c"
}

static GObject *
bt_device_row_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BTDeviceRow * self;
	GtkStyleContext* _tmp0_;
	ObexManager* _tmp1_;
	ObexManager* _tmp2_;
	ObexManager* _tmp3_;
	GtkBox* box = NULL;
	GtkBox* _tmp4_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	Device1* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* icon_name = NULL;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp15_;
	GtkImage* _tmp16_ = NULL;
	GtkImage* _tmp17_;
	GtkStyleContext* _tmp18_;
	Device1* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	Device1* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkRevealer* _tmp29_ = NULL;
	GtkBox* battery_box = NULL;
	GtkBox* _tmp30_;
	GtkImage* _tmp31_;
	PangoAttrList* label_attributes = NULL;
	PangoAttrList* _tmp32_;
	PangoFontDescription* desc = NULL;
	PangoFontDescription* _tmp33_;
	PangoFontDescription* _tmp34_;
	PangoFontDescription* _tmp35_;
	PangoAttrList* _tmp36_;
	PangoFontDescription* _tmp37_;
	PangoAttrFontDesc* _tmp38_;
	PangoAttrList* _tmp39_;
	PangoAttrList* _tmp40_;
	GtkLabel* _tmp41_ = NULL;
	GtkLabel* _tmp42_;
	GtkStyleContext* _tmp43_;
	GtkLabel* _tmp44_;
	GtkStyleContext* _tmp45_;
	GtkBox* _tmp46_;
	GtkImage* _tmp47_;
	GtkBox* _tmp48_;
	GtkLabel* _tmp49_;
	GtkRevealer* _tmp50_;
	GtkBox* _tmp51_;
	GtkBox* status_box = NULL;
	GtkBox* _tmp52_;
	GtkRevealer* _tmp53_ = NULL;
	GtkRevealer* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkSpinner* _tmp56_;
	PangoAttrList* _tmp57_;
	PangoAttrList* _tmp58_;
	GtkLabel* _tmp59_ = NULL;
	GtkLabel* _tmp60_;
	GtkStyleContext* _tmp61_;
	GtkLabel* _tmp62_;
	GtkStyleContext* _tmp63_;
	GtkRevealer* _tmp64_;
	GtkSpinner* _tmp65_;
	GtkBox* _tmp66_;
	GtkLabel* _tmp67_;
	GtkBox* _tmp68_;
	GtkRevealer* _tmp69_;
	GtkBox* button_box = NULL;
	GtkBox* _tmp70_ = NULL;
	gchar* _tmp71_;
	GtkButton* _tmp72_ = NULL;
	GtkButton* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkButton* _tmp75_;
	gchar* _tmp76_;
	GtkButton* _tmp77_ = NULL;
	GtkButton* _tmp78_;
	GtkStyleContext* _tmp79_;
	GtkButton* _tmp80_;
	GtkStyleContext* _tmp81_;
	GtkButton* _tmp82_;
	GtkBox* _tmp83_;
	GtkButton* _tmp84_;
	GtkBox* _tmp85_;
	GtkButton* _tmp86_;
	GtkRevealer* _tmp87_ = NULL;
	GtkLabel* _tmp88_ = NULL;
	GtkProgressBar* _tmp89_ = NULL;
	GtkLabel* _tmp90_ = NULL;
	GtkGrid* progress_grid = NULL;
	GtkGrid* _tmp91_;
	GtkGrid* _tmp92_;
	GtkLabel* _tmp93_;
	GtkGrid* _tmp94_;
	GtkProgressBar* _tmp95_;
	GtkGrid* _tmp96_;
	GtkLabel* _tmp97_;
	GtkRevealer* _tmp98_;
	GtkGrid* _tmp99_;
	Device1* _tmp100_;
	GtkGrid* _tmp101_;
	GtkImage* _tmp102_;
	GtkGrid* _tmp103_;
	GtkLabel* _tmp104_;
	GtkGrid* _tmp105_;
	GtkBox* _tmp106_;
	GtkGrid* _tmp107_;
	GtkBox* _tmp108_;
	GtkGrid* _tmp109_;
	GtkRevealer* _tmp110_;
	GtkGrid* box_grid = NULL;
	GtkGrid* _tmp111_;
	GtkGrid* _tmp112_;
	GtkGrid* _tmp113_;
	GtkGrid* _tmp114_;
	GtkRevealer* _tmp115_;
	GtkBox* _tmp116_;
	GtkGrid* _tmp117_;
	GtkBox* _tmp118_;
	GtkButton* _tmp119_;
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	parent_class = G_OBJECT_CLASS (bt_device_row_parent_class);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_DEVICE_ROW, BTDeviceRow);
#line 350 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 350 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp0_, "bluetooth-device-row");
#line 353 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->_obex_manager;
#line 353 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp1_, "transfer-active", (GCallback) _bt_device_row_transfer_active_obex_manager_transfer_active, self, 0);
#line 354 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->priv->_obex_manager;
#line 354 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp2_, "transfer-added", (GCallback) _bt_device_row_transfer_added_obex_manager_transfer_added, self, 0);
#line 355 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->priv->_obex_manager;
#line 355 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp3_, "transfer-removed", (GCallback) _bt_device_row_transfer_removed_obex_manager_transfer_removed, self, 0);
#line 358 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 358 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp4_);
#line 358 "../src/panel/applets/status/BluetoothIndicator.vala"
	box = _tmp4_;
#line 359 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp5_ = (GtkGrid*) gtk_grid_new ();
#line 359 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_set_column_spacing (_tmp5_, 6);
#line 359 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 359 "../src/panel/applets/status/BluetoothIndicator.vala"
	grid = _tmp5_;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp7_ = self->priv->_device;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp8_ = device1_get_icon (_tmp7_);
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp9_ = _tmp8_;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = _tmp9_;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (_tmp6_ == NULL) {
#line 4122 "BluetoothIndicator.c"
		gchar* _tmp10_;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp10_ = g_strdup ("bluetooth-active");
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (_tmp6_);
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp6_ = _tmp10_;
#line 4130 "BluetoothIndicator.c"
	}
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp11_ = _tmp6_;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp6_ = NULL;
#line 363 "../src/panel/applets/status/BluetoothIndicator.vala"
	icon_name = _tmp11_;
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp12_ = icon_name;
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
	if (!g_str_has_suffix (_tmp12_, "-symbolic")) {
#line 4142 "BluetoothIndicator.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp13_ = icon_name;
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
		_tmp14_ = g_strconcat (_tmp13_, "-symbolic", NULL);
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
		_g_free0 (icon_name);
#line 364 "../src/panel/applets/status/BluetoothIndicator.vala"
		icon_name = _tmp14_;
#line 4153 "BluetoothIndicator.c"
	}
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp15_ = icon_name;
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp15_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp16_, 4);
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp16_, 4);
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp16_);
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 365 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->image = _tmp16_;
#line 369 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp17_ = self->priv->image;
#line 369 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 369 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp18_, "bluetooth-device-image");
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp19_ = self->priv->_device;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp20_ = device1_get_alias (_tmp19_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp21_ = _tmp20_;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp22_ = _tmp21_;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp23_ = self->priv->_device;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp24_ = device1_get_alias (_tmp23_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp25_ = _tmp24_;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_tmp22_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_xalign (_tmp26_, 0.0f);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_max_width_chars (_tmp26_, 1);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_ellipsize (_tmp26_, PANGO_ELLIPSIZE_END);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp26_, TRUE);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp26_, _tmp25_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp25_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp26_);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->name_label);
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->name_label = _tmp26_;
#line 371 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp22_);
#line 379 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp27_ = self->priv->name_label;
#line 379 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
#line 379 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp28_, "bluetooth-device-name");
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp29_ = (GtkRevealer*) gtk_revealer_new ();
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_tmp29_, FALSE);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_duration (_tmp29_, (guint) 250);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_type (_tmp29_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp29_, 2);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp29_);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_revealer);
#line 381 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_revealer = _tmp29_;
#line 388 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 388 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp30_);
#line 388 "../src/panel/applets/status/BluetoothIndicator.vala"
	battery_box = _tmp30_;
#line 390 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp31_ = (GtkImage*) gtk_image_new ();
#line 390 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp31_);
#line 390 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_icon);
#line 390 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_icon = _tmp31_;
#line 392 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp32_ = pango_attr_list_new ();
#line 392 "../src/panel/applets/status/BluetoothIndicator.vala"
	label_attributes = _tmp32_;
#line 393 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp33_ = pango_font_description_new ();
#line 393 "../src/panel/applets/status/BluetoothIndicator.vala"
	desc = _tmp33_;
#line 394 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp34_ = desc;
#line 394 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_font_description_set_stretch (_tmp34_, PANGO_STRETCH_ULTRA_CONDENSED);
#line 395 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp35_ = desc;
#line 395 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_font_description_set_weight (_tmp35_, PANGO_WEIGHT_SEMILIGHT);
#line 396 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp36_ = label_attributes;
#line 396 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp37_ = desc;
#line 396 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp38_ = (PangoAttrFontDesc*) pango_attr_font_desc_new (_tmp37_);
#line 396 "../src/panel/applets/status/BluetoothIndicator.vala"
	pango_attr_list_insert (_tmp36_, (PangoAttribute*) _tmp38_);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp39_ = label_attributes;
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp40_ = _pango_attr_list_ref0 (_tmp39_);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp41_ = (GtkLabel*) gtk_label_new (NULL);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_attributes (_tmp41_, _tmp40_);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (_tmp40_);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp41_, GTK_ALIGN_START);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp41_);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_label);
#line 398 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_label = _tmp41_;
#line 402 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp42_ = self->priv->battery_label;
#line 402 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp43_ = gtk_widget_get_style_context ((GtkWidget*) _tmp42_);
#line 402 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp43_, GTK_STYLE_CLASS_DIM_LABEL);
#line 403 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp44_ = self->priv->battery_label;
#line 403 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
#line 403 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp45_, "bluetooth-battery-label");
#line 405 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp46_ = battery_box;
#line 405 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp47_ = self->priv->battery_icon;
#line 405 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp46_, (GtkWidget*) _tmp47_, FALSE, FALSE, (guint) 2);
#line 406 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp48_ = battery_box;
#line 406 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp49_ = self->priv->battery_label;
#line 406 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp48_, (GtkWidget*) _tmp49_, FALSE, FALSE, (guint) 2);
#line 408 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp50_ = self->priv->battery_revealer;
#line 408 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp51_ = battery_box;
#line 408 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 411 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp52_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 411 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp52_);
#line 411 "../src/panel/applets/status/BluetoothIndicator.vala"
	status_box = _tmp52_;
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp53_ = (GtkRevealer*) gtk_revealer_new ();
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_tmp53_, FALSE);
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_duration (_tmp53_, (guint) 250);
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_type (_tmp53_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp53_);
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->revealer);
#line 413 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->revealer = _tmp53_;
#line 418 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp54_ = self->priv->revealer;
#line 418 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
#line 418 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp55_, "bluetooth-device-revealer");
#line 420 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp56_ = (GtkSpinner*) gtk_spinner_new ();
#line 420 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp56_);
#line 420 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->spinner);
#line 420 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->spinner = _tmp56_;
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp57_ = label_attributes;
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp58_ = _pango_attr_list_ref0 (_tmp57_);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp59_ = (GtkLabel*) gtk_label_new (NULL);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_attributes (_tmp59_, _tmp58_);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (_tmp58_);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp59_, GTK_ALIGN_START);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp59_);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->status_label);
#line 422 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->status_label = _tmp59_;
#line 426 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp60_ = self->priv->status_label;
#line 426 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
#line 426 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp61_, "bluetooth-device-status");
#line 427 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp62_ = self->priv->status_label;
#line 427 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp63_ = gtk_widget_get_style_context ((GtkWidget*) _tmp62_);
#line 427 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp63_, GTK_STYLE_CLASS_DIM_LABEL);
#line 429 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp64_ = self->priv->revealer;
#line 429 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp65_ = self->priv->spinner;
#line 429 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
#line 430 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp66_ = status_box;
#line 430 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp67_ = self->priv->status_label;
#line 430 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp66_, (GtkWidget*) _tmp67_, FALSE, TRUE, (guint) 0);
#line 431 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp68_ = status_box;
#line 431 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp69_ = self->priv->revealer;
#line 431 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp68_, (GtkWidget*) _tmp69_, FALSE, TRUE, (guint) 0);
#line 433 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp70_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 433 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_set_homogeneous (_tmp70_, FALSE);
#line 433 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp70_);
#line 433 "../src/panel/applets/status/BluetoothIndicator.vala"
	button_box = _tmp70_;
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp71_ = g_strdup (_ ("Send file"));
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp72_ = (GtkButton*) gtk_button_new_from_icon_name ("folder-download-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_button_set_relief (_tmp72_, GTK_RELIEF_NONE);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp72_, _tmp71_);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp71_);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp72_);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->send_button);
#line 438 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->send_button = _tmp72_;
#line 442 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp73_ = self->priv->send_button;
#line 442 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp74_ = gtk_widget_get_style_context ((GtkWidget*) _tmp73_);
#line 442 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp74_, "circular");
#line 443 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp75_ = self->priv->send_button;
#line 443 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp75_, "clicked", (GCallback) __bt_device_row___lambda20__gtk_button_clicked, self, 0);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp76_ = g_strdup (_ ("Disconnect"));
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp77_ = (GtkButton*) gtk_button_new_from_icon_name ("bluetooth-disabled-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_button_set_relief (_tmp77_, GTK_RELIEF_NONE);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp77_, _tmp76_);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp76_);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp77_);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->connection_button);
#line 463 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->connection_button = _tmp77_;
#line 467 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp78_ = self->priv->connection_button;
#line 467 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp79_ = gtk_widget_get_style_context ((GtkWidget*) _tmp78_);
#line 467 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp79_, "circular");
#line 468 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp80_ = self->priv->connection_button;
#line 468 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp81_ = gtk_widget_get_style_context ((GtkWidget*) _tmp80_);
#line 468 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp81_, "bluetooth-connection-button");
#line 469 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp82_ = self->priv->connection_button;
#line 469 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp82_, "clicked", (GCallback) __bt_device_row___lambda21__gtk_button_clicked, self, 0);
#line 473 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp83_ = button_box;
#line 473 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp84_ = self->priv->send_button;
#line 473 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp83_, (GtkWidget*) _tmp84_, TRUE, TRUE, (guint) 0);
#line 474 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp85_ = button_box;
#line 474 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp86_ = self->priv->connection_button;
#line 474 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp85_, (GtkWidget*) _tmp86_, TRUE, TRUE, (guint) 0);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp87_ = (GtkRevealer*) gtk_revealer_new ();
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_reveal_child (_tmp87_, FALSE);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_duration (_tmp87_, (guint) 250);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_revealer_set_transition_type (_tmp87_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_left ((GtkWidget*) _tmp87_, 4);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_right ((GtkWidget*) _tmp87_, 4);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp87_);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_revealer);
#line 477 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_revealer = _tmp87_;
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp88_ = (GtkLabel*) gtk_label_new (NULL);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp88_, GTK_ALIGN_START);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp88_, GTK_ALIGN_END);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_use_markup (_tmp88_, TRUE);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp88_, TRUE);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp88_);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 485 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_label = _tmp88_;
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp89_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp89_, TRUE);
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp89_, 6);
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp89_, 6);
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp89_);
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 492 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_bar = _tmp89_;
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp90_ = (GtkLabel*) gtk_label_new (NULL);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_ellipsize (_tmp90_, PANGO_ELLIPSIZE_MIDDLE);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp90_, GTK_ALIGN_START);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp90_, GTK_ALIGN_END);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_label_set_use_markup (_tmp90_, TRUE);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp90_, TRUE);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp90_);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->file_label);
#line 498 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->file_label = _tmp90_;
#line 506 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp91_ = (GtkGrid*) gtk_grid_new ();
#line 506 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp91_);
#line 506 "../src/panel/applets/status/BluetoothIndicator.vala"
	progress_grid = _tmp91_;
#line 507 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp92_ = progress_grid;
#line 507 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp93_ = self->priv->file_label;
#line 507 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 0, 0, 1, 1);
#line 508 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp94_ = progress_grid;
#line 508 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp95_ = self->priv->progress_bar;
#line 508 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 0, 1, 1, 1);
#line 509 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp96_ = progress_grid;
#line 509 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp97_ = self->priv->progress_label;
#line 509 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 0, 2, 1, 1);
#line 510 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp98_ = self->priv->progress_revealer;
#line 510 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp99_ = progress_grid;
#line 510 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp99_);
#line 513 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp100_ = self->priv->_device;
#line 513 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) _bt_device_row_update_status_g_dbus_proxy_g_properties_changed, self, 0);
#line 516 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp101_ = grid;
#line 516 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp102_ = self->priv->image;
#line 516 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp101_, (GtkWidget*) _tmp102_, 0, 0, 2, 2);
#line 517 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp103_ = grid;
#line 517 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp104_ = self->priv->name_label;
#line 517 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp104_, 2, 0, 2, 1);
#line 518 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp105_ = grid;
#line 518 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp106_ = button_box;
#line 518 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp105_, (GtkWidget*) _tmp106_, 4, 0, 1, 2);
#line 519 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp107_ = grid;
#line 519 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp108_ = status_box;
#line 519 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp107_, (GtkWidget*) _tmp108_, 2, 1, 2, 1);
#line 520 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp109_ = grid;
#line 520 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp110_ = self->priv->battery_revealer;
#line 520 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp109_, (GtkWidget*) _tmp110_, 2, 2, 1, 1);
#line 522 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp111_ = (GtkGrid*) gtk_grid_new ();
#line 522 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp111_);
#line 522 "../src/panel/applets/status/BluetoothIndicator.vala"
	box_grid = _tmp111_;
#line 523 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp112_ = box_grid;
#line 523 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp113_ = grid;
#line 523 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp112_, (GtkWidget*) _tmp113_, 0, 0, 1, 1);
#line 524 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp114_ = box_grid;
#line 524 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp115_ = self->priv->progress_revealer;
#line 524 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_grid_attach (_tmp114_, (GtkWidget*) _tmp115_, 0, 1, 1, 1);
#line 526 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp116_ = box;
#line 526 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp117_ = box_grid;
#line 526 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (_tmp116_, (GtkWidget*) _tmp117_, TRUE, TRUE, (guint) 0);
#line 527 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp118_ = box;
#line 527 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp118_);
#line 529 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 530 "../src/panel/applets/status/BluetoothIndicator.vala"
	_tmp119_ = self->priv->send_button;
#line 530 "../src/panel/applets/status/BluetoothIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp119_);
#line 531 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_update_status (self);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (box_grid);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (progress_grid);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (button_box);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (status_box);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	__vala_PangoFontDescription_free0 (desc);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_pango_attr_list_unref0 (label_attributes);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (battery_box);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (icon_name);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_free0 (_tmp6_);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (grid);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (box);
#line 349 "../src/panel/applets/status/BluetoothIndicator.vala"
	return obj;
#line 4671 "BluetoothIndicator.c"
}

static void
bt_device_row_class_init (BTDeviceRowClass * klass,
                          gpointer klass_data)
{
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_parent_class = g_type_class_peek_parent (klass);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_type_class_adjust_private_offset (klass, &BTDeviceRow_private_offset);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bt_device_row_get_property;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bt_device_row_set_property;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->constructor = bt_device_row_constructor;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = bt_device_row_finalize;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BT_DEVICE_ROW_DEVICE_PROPERTY, bt_device_row_properties[BT_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", TYPE_DEVICE1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY, bt_device_row_properties[BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY] = g_param_spec_object ("obex-manager", "obex-manager", "obex-manager", TYPE_OBEX_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BT_DEVICE_ROW_UP_DEVICE_PROPERTY, bt_device_row_properties[BT_DEVICE_ROW_UP_DEVICE_PROPERTY] = g_param_spec_object ("up-device", "up-device", "up-device", up_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	bt_device_row_signals[BT_DEVICE_ROW_PROPERTIES_UPDATED_SIGNAL] = g_signal_new ("properties-updated", TYPE_BT_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4698 "BluetoothIndicator.c"
}

static void
bt_device_row_instance_init (BTDeviceRow * self,
                             gpointer klass)
{
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv = bt_device_row_get_instance_private (self);
#line 307 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->image = NULL;
#line 308 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->name_label = NULL;
#line 309 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_revealer = NULL;
#line 310 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_icon = NULL;
#line 311 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->battery_label = NULL;
#line 312 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->revealer = NULL;
#line 313 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->spinner = NULL;
#line 314 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->status_label = NULL;
#line 315 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->send_button = NULL;
#line 316 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->connection_button = NULL;
#line 317 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_revealer = NULL;
#line 318 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->file_label = NULL;
#line 319 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_label = NULL;
#line 320 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->progress_bar = NULL;
#line 326 "../src/panel/applets/status/BluetoothIndicator.vala"
	self->priv->up_handler_id = (gulong) 0;
#line 4737 "BluetoothIndicator.c"
}

static void
bt_device_row_finalize (GObject * obj)
{
	BTDeviceRow * self;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_DEVICE_ROW, BTDeviceRow);
#line 307 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 308 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->name_label);
#line 309 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_revealer);
#line 310 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_icon);
#line 311 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->battery_label);
#line 312 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->revealer);
#line 313 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->spinner);
#line 314 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->status_label);
#line 315 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->send_button);
#line 316 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->connection_button);
#line 317 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_revealer);
#line 318 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->file_label);
#line 319 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 320 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 322 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->_device);
#line 323 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->_obex_manager);
#line 324 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->transfer);
#line 327 "../src/panel/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->_up_device);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (bt_device_row_parent_class)->finalize (obj);
#line 4784 "BluetoothIndicator.c"
}

/**
 * Widget for displaying a Bluetooth device in a ListBox.
 */
GType
bt_device_row_get_type (void)
{
	return bt_device_row_type_id;
}

GType
bt_device_row_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BTDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bt_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BTDeviceRow), 0, (GInstanceInitFunc) bt_device_row_instance_init, NULL };
	bt_device_row_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "BTDeviceRow", &g_define_type_info, 0);
	BTDeviceRow_private_offset = sizeof (BTDeviceRowPrivate);
	return bt_device_row_type_id;
}

static void
_vala_bt_device_row_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	BTDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_DEVICE_ROW, BTDeviceRow);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	switch (property_id) {
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_DEVICE_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_value_set_object (value, bt_device_row_get_device (self));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_value_set_object (value, bt_device_row_get_obex_manager (self));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_UP_DEVICE_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		g_value_set_object (value, bt_device_row_get_up_device (self));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 4833 "BluetoothIndicator.c"
		default:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 4839 "BluetoothIndicator.c"
	}
}

static void
_vala_bt_device_row_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	BTDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_DEVICE_ROW, BTDeviceRow);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
	switch (property_id) {
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_DEVICE_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_set_device (self, g_value_get_object (value));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_OBEX_MANAGER_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_set_obex_manager (self, g_value_get_object (value));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		case BT_DEVICE_ROW_UP_DEVICE_PROPERTY:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		bt_device_row_set_up_device (self, g_value_get_object (value));
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 4871 "BluetoothIndicator.c"
		default:
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 300 "../src/panel/applets/status/BluetoothIndicator.vala"
		break;
#line 4877 "BluetoothIndicator.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

